﻿import utils.CustomButton;

class slideshowsinglemultipleselect.QuizElement extends MovieClip {
	private var idTxt:TextField;
	private var qTxt:TextField;
	private var qObj:Object;
	private var mcArray:Array;
	private var correctAnswer:Array;
	private var selectedItem:Array;
	
	
	
	function QuizElement() {
		this.onLoad = function () {
			init();
		}
	}
	
	private function init() {
		if (qObj.Options.correctAns.length > 1) {
			correctAnswer = qObj.Options.correctAns.split(",");
			var len = correctAnswer.length;
			for (var k = 0; k < len; k++) {
				correctAnswer[k] = Number(correctAnswer[k]);
			}
		} else {
			correctAnswer = new Array();
			correctAnswer.push(Number(qObj.Options.correctAns))
		}
		
		selectedItem = new Array();
		qTxt.autoSize = "left";
		idTxt.text = qObj.id + ".";
		qTxt.htmlText = qObj.QuestionTxt._value;
		var len = qObj.Options.Option.length;
		mcArray = new Array();
		for (var k = 0; k < len; k++) {
			var opmc = this.attachMovie("SingleSelectItem", "sitem" + k, k + 1, {sObj:qObj.Options.Option[k]});
			//opmc._y = qTxt._y + qTxt.textHeight + 15;
			//opmc._x = (k * this._width / 2);
			opmc._x = qTxt._x - 20;
			var ht = opmc._height < 30 ? 30 : opmc._height;
			opmc._y = qTxt._y + qTxt._textHeight + 45 + (k * ht);
			mcArray.push(opmc);
		}
		_parent.reArrangeElements();
	}
	
	public function handleOptionSelection(num:Number, flag:Boolean) {
		// this is for multiple type commented now
		var len = mcArray.length;
		if (correctAnswer.length > 1) {
			var nowSelected = flag ? false : true;
			selectedItem[num - 1] = nowSelected;
			for (var k = 0; k < len; k++) {
				if (num == mcArray[k].getIndex()) {
					mcArray[k].setSelection(nowSelected);
				}
			}
			
		} else {
			selectedItem[0] = num;
			for (var k = 0; k < len; k++) {
				if (num == mcArray[k].getIndex()) {
					mcArray[k].setSelection(true);
				} else {
					mcArray[k].setSelection(false);
				}
			}
		}
		_parent.changeSubmitButtonState(true);
	}
	
	public function showCorrectAnswer() {
		makeOptionsButtonsState(false);
		var len = correctAnswer.length;
		trace("in quiz element == " + len);
		for (var k = 0; k < len; k++) {
			mcArray[correctAnswer[k] - 1].showCorrectAnswer();
		}
	}
	
	public function checkResult() {
		var correct = false;
		if (correctAnswer.length > 1) {
			var len = correctAnswer.length;
			var bool = true;
			var totalTrue = 0;
			for (var k = 0; k < len; k++) {
				if (selectedItem[correctAnswer[k] - 1] != true) {
					bool = false;
					
				}
			}
			var len = selectedItem.length;
			for (var k = 0; k < len; k++) {
				if (selectedItem[k]) {
					totalTrue++;
				}
			}
			
			if (correctAnswer.length != totalTrue) {
				bool = false;
			}
			if (bool) {
				correct = true;
			} else {
				correct = false;
			}
		} else {
			if (selectedItem[0] == correctAnswer[0]) {
				correct = true;
			} else {
				correct = false;
			}
		}
		
		
		return correct;
	}
	
	public function makeOptionsButtonsState(flag) {
		var len = mcArray.length;
		for (var k = 0; k < len; k++) {
			mcArray[k].changeState(flag);
		}
	}
}