﻿import utils.ImageHolder;
import utils.XML2Obj;
import utils.CustomButton;

class slideshowsinglemultipleselect.SlideShowSingleMultipleSelect extends MovieClip {
	private var sObj:Object;
	private var totalPages:Number;
	private var nextBtn:CustomButton;
	private var prevBtn:CustomButton;
	private var titleTxt:TextField;
	private var descTxt:TextField;
	private var quizbg:MovieClip;
	private var submitBtn:CustomButton;
	private var attempted:Number;
	private var numberOfTries:Number;
	private var feedbackMC:MovieClip;
	private var currentIndex:Number;
	private var isShowCorrectAnswer:Boolean;
	private var numToLoad:Number;
	private var imgCount:Number;
	
	function SlideShowSingleMultipleSelect() {
		this.onLoad = function () {
			init();
		}
	}
	
	private function init() {
		numToLoad = 0;
		imgCount = 0;
		this._visible = false;
		_root.temppath = this;
		isShowCorrectAnswer = true; // to show correct answer right mark
		nextBtn.initButton("Next", "handleNext", this);
		submitBtn.initButton("", "handleSubmit", this);
		
		changeSubmitButtonState(false);
		nextBtn._visible = false;
		makeNextButtonState(false);
		
		
		var file = _root.sourcePath + "xml/" + _root.application.getTemplateXMLFile();
		var myxml:XML = new XML();
		myxml.ignoreWhite = true;
		
		myxml.onLoad = function (success) {
			if (success) {
				var xo:XML2Obj = new XML2Obj();
				var tObj = xo.getxObjFromXML(this.toString());
				_root.temppath.handleXMLLoad(tObj);	
				delete xo;
				delete tObj;
			} else {
				myxml.load(file);
			}
		}
		myxml.load(file);
	}
	
	public function handleImageLoaded() {
		imgCount++;
		trace(numToLoad + " :: " + imgCount);
		if (imgCount >= numToLoad) {
			_parent._parent.showPreloader(false);
			this._visible = true;
			
		}
	}
	
	
	public function handleXMLLoad(obj) {
		sObj = obj.Data;
		var len = sObj.Pages.Page.length;
		sObj.pagesArr = new Array();
		var len = sObj.Pages.Page.length;
		if (len == undefined) {
			sObj.pagesArr[0] = sObj.Pages.Page;
		} else {
			sObj.pagesArr = sObj.Pages.Page;
		}
		
		
		
		totalPages = sObj.pagesArr.length;
		
		
		
		handleImageLoaded();
		currentIndex = 0;
		showPageDetails();
		
		
	}
	
	public function handleNext() {
		currentIndex++;
		showPageDetails();
	}
	
	public function showPageDetails(num) {
		isShowCorrectAnswer = true; // to show correct answer right mark
		feedbackMC.gotoAndStop("none");
		var pageObj = sObj.pagesArr[currentIndex];
		titleTxt.htmlText = pageObj.title._value;
		descTxt.htmlText = pageObj.Desc._value;
		descTxt._y = titleTxt._y + titleTxt.textHeight + 10;
		sObj.mcArray = new Array();
		sObj.cIndex = 0;
		
		var len2 = pageObj.Quiz.length;
		if (len2 == undefined) {
			var arr = new Array();
			var obj = pageObj.Quiz;
			arr.push(obj);
			pageObj.Quiz = arr;
		}
		
		var numToShow = pageObj.Quiz.length;
		var lastmc;
		for (var k = 0; k < numToShow; k++) {
			var mc = this.attachMovie("QuizElement", "qlement" + k, k + 1, {qObj:pageObj.Quiz[k]});
			mc._x = quizbg._x + 5;
			mc._y = quizbg._y + 10 + (k * lastmc._height + 5);
			lastmc = mc;
			sObj.mcArray.push(mc);
			
		}
		attempted = 0;
		numberOfTries = Number(pageObj.numberOfTry);
		changeSubmitButtonState(false);
		
		
		
	}
	
	public function checkButtonStatus() {
		if (currentIndex >= totalPages - 1) {
			makeNextButtonState(false);
		} else {
			makeNextButtonState(true);
		}
	}
	
	public function makeNextButtonState(flag) {
		trace("in makeNextButtonState == " + flag);
		nextBtn.enabled = flag;
		//nextBtn._alpha = flag ? 100 : 50;
		nextBtn._visible = flag;
	}
	
	public function reArrangeElements() {
		sObj.cIndex++;
		if (sObj.cIndex == sObj.mcArray.length) {
			var len = sObj.mcArray.length;
			for (var k = 0; k < len; k++) {
				var dist = lastmc == undefined ? 30 : (lastmc._y + lastmc._height)
				sObj.mcArray[k]._y = quizbg._y + 10 + dist;
				var lastmc = sObj.mcArray[k];
			}
		}
		makeNextButtonState(false);
	}
	
	public function changeSubmitButtonState(flag:Boolean) {
		submitBtn.changeState(flag);
	}
	

	
	public function handleSubmit() {
		attempted++;
		var len = sObj.mcArray.length;
		var arr = new Array();
		for (var k = 0; k < len; k++) {
			arr.push(sObj.mcArray[k].checkResult());
		}
		var bool = true;
		var len = arr.length;
		trace("arr  " + arr)
		for (var k = 0; k < len; k++) {
			if (arr[k] == false) {
				bool = false;
				break;
			}
		}
		
		
		// check why this value is coming "     "
		//if (isShowCorrectAnswer) {
			showCorrectAnswer();
		//}
		
		
		changeSubmitButtonState(false);
		makeOptionButtonsState(false);
		if (currentIndex == totalPages - 1) {
			var fr = bool ? "correctLast" : "incorrectLast";
			//_parent.changeSubmitButtonState(false);
		} else {
			var fr = bool ? "correct" : "incorrect";
		}
		feedbackMC.gotoAndStop(fr);
		
		
		checkButtonStatus();
	}
	
	public function showFeedbackText(fr:String) {
		var str = ""
		var num = Number(sObj.pagesArr[currentIndex].Quiz.id);
		if (num == undefined) {
			num = 0;
		}
		if (fr == "correct") {
			str = sObj.pagesArr[currentIndex].Quiz[num].correctFeedback._value;
		} else if (fr == "incorrect") {
			str = sObj.pagesArr[currentIndex].Quiz[num].incorrectFeedback._value;
		} else if (fr == "incorrectLast") {
			str = sObj.pagesArr[currentIndex].Quiz[num].incorrectFeedbackLast._value;
		}
		
		trace("in showFeedbacktext == " + str);
		feedbackMC.fTxt.htmlText = str;
	}
	
	public function showCorrectAnswer() {
		
		var len = sObj.mcArray.length;
		for (var k = 0; k < len; k++) {
			sObj.mcArray[k].showCorrectAnswer();
		}
	}
	
	public function makeOptionButtonsState(flag) {
		var len = sObj.mcArray.length;
		for (var k = 0; k < len; k++) {
			sObj.mcArray[k].makeOptionsButtonsState(flag);
		}
	}
	
}