﻿//Has functions related to fetching the User details from the database
//currently we are implementing XML database
XMLDBPath = "resources/userData/userDB.xml";
courseStructurePath = "content/courseStructure.xml";
masterXMLPath = "content/masterXML.xml";
helpStructurePath = "help/xml/help.xml";

//function fetches the User XML and compares the accessKey sent as param
//if matched with any entry in DB, it returns the userName with a SUCCESS flag 
//or else sends the Error message with ERROR flag
//The return type is an Object
function fetchUser(userAccKey:String, callBackFn:Function):Void{
	var tXML:XML = new XML();
	var i:Number = 0;
	var retObj:Object = new Object();
	retObj.value = "Problem while connecting to Data Store. Contact Administrator";
	retObj.flag = "ERROR";
	var userFound:Boolean = false;
	
	tXML.load(XMLDBPath);
	tXML.onLoad  = function(success){
		if(success){
			var xo:XML2Obj = new XML2Obj();
			var tObj = xo.getxObjFromXML(this.toString());
			var userLen = 0;
			
			if(tObj.userList.user.length == undefined){
				var tempObj = tObj.userList.user;
				tObj.userList.user = new Array();
				tObj.userList.user[0] = tempObj;
			}
			
			userLen = tObj.userList.user.length;
			
			for(i=0;i<userLen;i++){
				if(userAccKey == tObj.userList.user[i].accessKey){
					retObj.flag = "SUCCESS";
					_global.accessKey = userAccKey;
					retObj.value = tObj.userList.user[i].userName._value;
					userFound = true;
					break;
				}
			}
			
			if(!userFound){
				retObj.flag = "ERROR";
				retObj.value = "Invalid Entry";				
			}
		}else{
			retObj.flag = "ERROR";
			retObj.value = "Error fetching data. Please contact Administrator";	
		}
		callBackFn(retObj);
	}
}

//fetches the content structure
function fetchContentStructure(callBackFn:Function):Void{
	var tXML:XML = new XML();	
	
	tXML.load(courseStructurePath);
	tXML.onLoad  = function(success){
		if(success){
			var xo:XML2Obj = new XML2Obj();
			var tObj = xo.getxObjFromXML(this.toString());
			
			callBackFn(tObj.courseStructure);
		}
	}
}

// fetches help content xml structure
function fetchHelpStructure(callBackFn:Function):Void{
	var tXML:XML = new XML();	
	
	tXML.load(helpStructurePath);
	tXML.onLoad  = function(success){
		if(success){
			var xo:XML2Obj = new XML2Obj();
			var tObj = xo.getxObjFromXML(this.toString());
			callBackFn(tObj.content);
		}
	}
}


//fetches the content structure
function fetchMasterXML(callBackFn:Function):Void{
	var tXML:XML = new XML();	
	
	tXML.load(masterXMLPath);
	tXML.onLoad  = function(success){
		if(success){
			var xo:XML2Obj = new XML2Obj();
			var tObj = xo.getxObjFromXML(this.toString());
			
			callBackFn(tObj.masterData);
		}
	}
}