function getSelectedRadio(buttonGroup) {
   // returns the array number of the selected radio button or -1 if no button is selected
   if (buttonGroup[0]) { // if the button group is an array (one button is not an array)
      for (var i=0; i<buttonGroup.length; i++) {
         if (buttonGroup[i].checked) {
            return i
         }
      }
   } else {
      if (buttonGroup.checked) { return 0; } // if the one button is checked, return zero
   }
   // if we get to this point, no radio button is selected
   return -1;
} // Ends the "getSelectedRadio" function

function getSelectedRadioValue(buttonGroup) {
   // returns the value of the selected radio button or "" if no button is selected
   var i = getSelectedRadio(buttonGroup);
   if (i == -1) {
      return "";
   } else {
      if (buttonGroup[i]) { // Make sure the button group is an array (not just one button)
         return buttonGroup[i].value;
      } else { // The button group is just the one button, and it is checked
         return buttonGroup.value;
      }
   }
} // Ends the "getSelectedRadioValue" function

function getSelectedCheckbox(buttonGroup) {
   // Go through all the check boxes. return an array of all the ones
   // that are selected (their position numbers). if no boxes were checked,
   // returned array will be empty (length will be zero)
   var retArr = new Array();
   var lastElement = 0;
   if (buttonGroup[0]) { // if the button group is an array (one check box is not an array)
      for (var i=0; i<buttonGroup.length; i++) {
         if (buttonGroup[i].checked) {
            retArr.length = lastElement;
            retArr[lastElement] = i;
            lastElement++;
         }
      }
   } else { // There is only one check box (it's not an array)
      if (buttonGroup.checked) { // if the one check box is checked
         retArr.length = lastElement;
         retArr[lastElement] = 0; // return zero as the only array value
      }
   }
   return retArr;
} // Ends the "getSelectedCheckbox" function

function getSelectedCheckboxValue(buttonGroup) {
   // return an array of values selected in the check box group. if no boxes
   // were checked, returned array will be empty (length will be zero)
   var retArr = new Array(); // set up empty array for the return values
   var retStr = "";
   var selectedItems = getSelectedCheckbox(buttonGroup);
   if (selectedItems.length != 0) { // if there was something selected
      retArr.length = selectedItems.length;
      for (var i=0; i<selectedItems.length; i++) {
         if (buttonGroup[selectedItems[i]]) { // Make sure it's an array
            retArr[i] = buttonGroup[selectedItems[i]].value;
            if(i!=selectedItems.length-1)
            	retStr = retStr + buttonGroup[selectedItems[i]].value + ",";
            else
            	retStr = retStr + buttonGroup[selectedItems[i]].value ;
         } else { // It's not an array (there's just one check box and it's selected)
            retArr[i] = buttonGroup.value;// return that value
            retStr = buttonGroup.value;// return that value;
         }
      }
   }
   //return retArr;
   //alert(retStr);
   return retStr;
} // Ends the "getSelectedCheckBoxValue" function

function sendData(){
var q1 = getSelectedRadioValue(document.survey.q1);
var q2 =getSelectedRadioValue(document.survey.q2);

var q3 = getSelectedCheckboxValue(document.survey.q3);
if(q3.indexOf("Other")!=-1){
q3 = q3 + "--" + document.survey.textfield1.value;

}

//var queryStr = 
var queryStr = "?q1=" + q1 + "&q2=" + q2 + "&q3="  + q3;


url = "http://210.18.17.98:8080/lc_almonds/updateDB.jsp" + queryStr;
//url = "http://localhost:8080/lc_almonds/updateDB.jsp" + queryStr;
//alert("url" + url);
window.parent.frames['topFrame'].location.href = url;

}