﻿import com.trina.parser.XMLParser;
import com.trina.utils.CustomButton;

class com.trina.assessments.AssessmentContainer extends MovieClip {
	private var __assessmentDetailsXML:String; // Details xml file
	private var __templatePath:String; // path where the assessment swfs will be stored
	private var __templateXMLPath:String; // path where the assessment xmls will be stored
	private var __showQuestionNumber:Boolean // Whether to show the question number
	private var __previousEnabled:Boolean // Whether to show Previous button or not
	private var __nextEnabled:Boolean // State of the next button at question loading
	private var __showFeedback:Boolean; // Whether to show feedback on submit button
	private var __promptAlign:String; // Prompt text alignment
	private var __passPercentage:Number;
	private var nextBtn:CustomButton;
	private var prevBtn:CustomButton;
	private var counterTxt:TextField;
	private var aObj:Object;
	private var pageObj:Object;
	private var containerMC:MovieClip;
	private var navObj:Object;
	private var loaderMC:MovieClip;
	private var answerArray:Array;
	private var __titleTxt:String;
	private var tTxt:TextField;
	private var isResultPage:Boolean;
	private var scoreTxt:TextField;
	private var totalAttempted:Number;
	private var promptTxt:TextField;
	private var backdropMC:MovieClip;
	private var headerTxt:TextField;

	
	
	function AssessmentContainer(){
		
		this.onLoad = function () {
			init();
		}
		this.onUnload = function () {
			this.unloadClip();
		}
	}
	
	
	public function init():Void {
		//--- making buttons invisible till the details xml loaded
		var obj = _parent.getObject();
		
		__assessmentDetailsXML = _global.aFile;
		__templatePath = "swfs/"
		var str = (obj.moduleNum < 10 ? ("0" + obj.moduleNum) : obj.moduleNum)
		__showQuestionNumber = true;
		setPassPercentage(_global.masteryScore == undefined ? 70 : _global.masteryScore);
		templateXMLPath = _root.getSelectedPath() + "xmls/";
		nextBtn.changeVisible(false);
		backdropMC._visible = false;
		prevBtn.changeVisible(false);
		prevBtn.initButton("Previous", "handlePrevious", this, 0x000000, 0x990000, 0x000000, "", true);
		nextBtn.initButton("Next", "handleNext", this, 0x000000, 0x990000, 0x000000, "", true);
		counterTxt.htmlText = "";
		promptTxt.htmlText = "";
		loadAssessmentDetails();
		setTitleTxt(_global.selectedVariantForAssessment);
		headerTxt.text = "Assessment Module : " + _global.selectedAggregateForAssessment;
		
	}
	
	
	private function loadAssessmentDetails():Void {
		if(XMLParser.getInstance() == undefined){
			XMLParser.initializeSingleton();
		}
		//XMLParser.initializeSingleton();
		var xp:XMLParser = XMLParser.getInstance();
		xp.readXML(__assessmentDetailsXML, "handleDetailsLoad", this);
	}

	public function handleDetailsLoad(obj:Object) {
		totalAttempted = 0;
		aObj = obj.Assessments;
		navObj = new Object();		
		makeProperArray();
		answerArray = new Array();
		navObj.currentTopicPos = 0;
		navObj.currentPos = 0;
		navObj.currentPagePos = 0;
		navObj.totalPages = getTotalPages();
		if (navObj.totalPages > 1) {
			nextBtn.changeVisible(true);
			prevBtn.changeVisible(true);
			backdropMC._visible = true;
		}
		if (getPreviousEnabled()) {
			prevBtn.changeVisible(true);
		} else {
			prevBtn.changeVisible(false);
		}
		showPage();
	}
	
	public function setAnswer(num:Number, flag:Boolean) {
		totalAttempted += num;
		answerArray[navObj.currentPagePos] = flag ? num : 0;
		
		var len = answerArray.length;
		var total = 0;
		for (var k = 0; k < len; k++) {
			if (answerArray[k] != undefined) {
				total += answerArray[k];
			}
		}
		var perc = Math.round((total / totalAttempted) * 100);
		if (perc > 0) {
			scoreTxt.text = "Score so far : " + total + " points out of " + totalAttempted + " (" + perc + "%)";
		} else {
			scoreTxt.text = "Score so far : " + total + " points out of " + totalAttempted;
		}
	}
	
	public function showResult() {
		unloadPage();
		
		var total = 0;
		var len = answerArray.length;
		for (var k = 0; k < len; k++) {
			if (answerArray[k] != undefined) {
				total += answerArray[k];
			}
		}
		
		isResultPage = true;
		
		var obj:Object = new Object();
		obj.score = total;
		totalAttempted = getTotalPoints();
		
		obj.total = totalAttempted;
		obj.passPercentage = getPassPercentage() == undefined ? 70 : getPassPercentage();
		var resultMC = this.attachMovie("assmntRptMC", "resultmc", this.getNextHighestDepth(), {rObj:obj});
		resultMC._x = 150;
		resultMC._y = 100;
		setNavigationDetails(false);
		// send values to LMS 
		var perc = Math.round((total / totalAttempted) * 100);
		if(perc >=passPercentage){
			var statusToLMS = "completed"
		}else{
			var statusToLMS = "incomplete"
		}
		_root.setScore(perc, statusToLMS); 
		_global.setAssessmentResult(perc, totalAttempted, total);
		//getURL("javascript:setScoreToLMS('"+perc+"', '"+statusToLMS+"')")
		setNextButtonState(false);
		nextBtn._visible = false;
		backdropMC._visible = false;
	}
	
	private function showPage() {
		isResultPage = false;
		pageObj = aObj.Topics.Topic[navObj.currentTopicPos].Pages.Page[navObj.currentPos];
		var file = getTemplatePath() + pageObj.swfName._value;
		loadPage(file);
		setNavigationDetails();
		if (getNextEnabled()) {
			
		} else {
			setNextButtonState(false);
		}
	}
	
	public function setNextButtonState(flag:Boolean) {
		if (navObj.currentPagePos == navObj.totalPages) {
			backdropMC._visible = true;
			nextBtn.changeState(false);
			backdropMC.gotoAndStop(1);
		} else {
			backdropMC._visible = true;
			nextBtn.changeState(flag);
			var fr = flag ? 2 : 1;
			backdropMC.gotoAndStop(fr);
		}
	}
	
	public function setNavigationDetails(flag:Boolean) {
		
		if (navObj.currentPagePos == 0) {
			prevBtn.changeState(false);
		} else {
			prevBtn.changeState(true);
		}
		
		if (navObj.currentPagePos == navObj.totalPages) {
			//nextBtn.initButton("Next", "goToTopics", _parent._parent, 0x000000, 0x990000, 0x000000, "", _parent._parent.checkLastPage());
			
		} else {
			nextBtn.changeState(true);
			backdropMC.gotoAndStop(2);
		}
		var num = navObj.currentPagePos + 1;
		if (isResultPage) {
			counterTxt.text = "";
		} else {
			counterTxt.text = "Page " + getString(num) + " of " + getString(navObj.totalPages);
		}
		
		var hStr1 = '<P Align="' + getPromptAlign() + '">'
		var hStr2 = '</P>';
		promptTxt.htmlText = pageObj.prompt._value == undefined ? "" : hStr1 + pageObj.prompt._value + hStr2;
	}
	
	public function getPagePrompt() {
		var hStr1 = '<P Align="' + getPromptAlign() + '">'
		var hStr2 = '</P>';
		var str = pageObj.prompt._value == undefined ? "" : hStr1 + pageObj.prompt._value + hStr2;
		return str;
	}
	
	public function handleNext() {
		navObj.currentPagePos++;
		var totalP = aObj.Topics.Topic[navObj.currentTopicPos].Pages.Page.length;
		if (navObj.currentPos == totalP - 1) {
			var totalT = aObj.Topics.Topic.length;
			if (navObj.currentTopicPos == totalT - 1) {
				showResult();
			} else {
				navObj.currentPos = 0;
				navObj.currentTopicPos++;
				showPage();
			}
		} else {
			navObj.currentPos++;
			showPage();
		}
	}
	
	public function handlePrevious() {
		navObj.currentPagePos--;
		if (navObj.currentPos == 0) {
			if (navObj.currentTopicPos == 0) {
				// start of assessment
			} else {
				navObj.currentTopicPos--;
				navObj.currentPos = aObj.Topics.Topic[navObj.currentTopicPos].Pages.Page.length - 1;
				showPage();
			}
		} else {
			navObj.currentPos--;
			showPage();
		}
		
	}
	
	public function getConfigObject() {
		var obj:Object = new Object();
		obj.xmlFile = pageObj.xmlName._value;
		obj.showId = __showQuestionNumber;
		obj.idText = "<font color='#666666'>Question </font><font color='#003366'>" + getString(getCurrentPageNumber()) + "<font color='#666666'> / " + getString(navObj.totalPages) + "</font>";
		obj.showFeedback = true; //getShowFeedback();
		obj.correctColor = aObj.correctColor._value;
		obj.incorrectColor = aObj.incorrectColor._value;
		obj.scoreValue = pageObj.score._value == undefined ? 1 : Number(pageObj.score._value);
		obj.isAssessment = true;
		return obj;
	}
	
	public function getXMLFile():String {
		return (templateXMLPath + pageObj.xmlName._value);
	}
	
	public function getWaitingInstruction() {
		return aObj.WaitingInstruction._value;
	}
	
	private function loadPage(file:String):Void {
		loaderMC.removeMovieClip();
		loaderMC = this.attachMovie("MoviePreloader", "lmc", this.getNextHighestDepth());
		// calculate centre position later -- TODO
		loaderMC._x = 335;
		loaderMC._y = 160;
		var mclListener:Object = new Object();
		mclListener.onLoadStart = function(target_mc:MovieClip) {
			
		};
		mclListener.onLoadComplete = function(target_mc:MovieClip) {
			
		};
		mclListener.onLoadInit = function(target_mc:MovieClip) {
			target_mc._parent.showImage();
		};
		var image_mcl:MovieClipLoader = new MovieClipLoader();
		image_mcl.addListener(mclListener);
		image_mcl.loadClip(file, containerMC);

	}
	
	private function unloadPage() {
		containerMC.unloadMovie();
		scoreTxt.text = "";
	}
	
	public function showImage() {
		loaderMC.removeMovieClip();
	}
	
	
	private function makeProperArray():Void {
		var len = aObj.Topics.Topic.length;
		if (len == undefined) {
			var arr:Array = new Array();
			var obj = aObj.Topics.Topic;
			arr.push(obj);
			aObj.Topics.Topic = arr;
		}
		len = aObj.Topics.Topic.length;
		for (var k = 0; k < len; k++) {
			var len1 = aObj.Topics.Topic[k].Pages.Page.length;
			if (len1 == undefined) {
				var arr:Array = new Array();
				var obj = aObj.Topics.Topic[k].Pages.Page;
				arr.push(obj);
				aObj.Topics.Topic[k].Pages.Page = arr;
			}
		}
	}
	
	private function getTotalPages() {
		var total:Number = 0;
		var len1 = aObj.Topics.Topic.length;
		for (var k = 0; k < len1; k++) {
			total += aObj.Topics.Topic[k].Pages.Page.length;
		}
		return total;
	}
	
	private function getTotalPoints() {
		var total:Number = 0;
		var len1 = aObj.Topics.Topic.length;
		for (var k = 0; k < len1; k++) {
			var pagesLen = aObj.Topics.Topic[k].Pages.Page.length;
			for (var i = 0; i < pagesLen; i++) {
				var sc = Number(aObj.Topics.Topic[k].Pages.Page[i].score._value) == undefined ? 1 : Number(aObj.Topics.Topic[k].Pages.Page[i].score._value)
				total += sc;
			}
			
		}
		return total;
	}
	
	private function getCurrentPageNumber():Number {
		var pageNo:Number = 0;
		if (navObj.currentTopicPos > 0) {
			for (var k = 0; k < navObj.currentTopicPos; k++) {
				pageNo += aObj.Topics.Topic[k].Pages.Page.length;
				
			}
		} 
		pageNo += navObj.currentPos + 1;
		return pageNo;
	}
	
	private function getString(num:Number) {
		return (num > 9 ? ("" + num) : ("0" + num));
	}

// Component definations................	
	[Inspectable(defaultValue="xmls/AssessmentDetails.xml")]
	function set assessmentDetailsXML(val:String):Void {
		__assessmentDetailsXML = val;
	}
	function get assessmentDetailsXML ():String {
		return __assessmentDetailsXML;
	}
	
	public function setAssessmentDetailsXML(val:String):Void {
		__assessmentDetailsXML = val;
	}
	public function getAssessmentDetailsXML():String {
		return __assessmentDetailsXML;
	}
	
	[Inspectable(defaultValue="content/templates/")]
	function set templatePath(val:String):Void {
		__templatePath = val;
	}
	function get templatePath():String {
		return __templatePath;
	}
	
	public function setTemplatePath(val:String):Void {
		__templatePath = val;
	}
	public function getTemplatePath():String {
		return __templatePath;
	}
	
	[Inspectable(defaultValue="")]
	function set templateXMLPath(val:String):Void {
		__templateXMLPath = val;
	}
	function get templateXMLPath():String {
		return __templateXMLPath;
	}
	
	public function setTemplateXMLPath(val:String):Void {
		__templateXMLPath = val;
	}
	public function getTemplateXMLPath():String {
		return __templateXMLPath;
	}
	
	[Inspectable(enumeration="true,false", defaultValue="true" type="String")]
	function set showQuestionNumber(flag:String):Void {
		__showQuestionNumber = flag == "true" ? true : false;
	}
	function get showQuestionNumber():Boolean {
		return __showQuestionNumber;
	}
	
	public function setShowQuestionNumber(flag:Boolean):Void {
		__showQuestionNumber = flag == "true" ? true : false;
	}
	public function getShowQuestionNumber():Boolean {
		return __showQuestionNumber;
	}
	
	[Inspectable(enumeration="true,false", defaultValue="false" type="String")]
	function set nextEnabled(flag:String):Void {
		__nextEnabled = flag == "true" ? true : false;
	}
	function get nextEnabled():Boolean {
		return __nextEnabled;
	}
	
	public function setNextEnabled(flag:Boolean):Void {
		__nextEnabled = flag == "true" ? true : false;
	}
	public function getNextEnabled():Boolean {
		return __nextEnabled;
	}
	
	[Inspectable(enumeration="true,false", defaultValue="true" type="String")]
	function set previousEnabled(flag:String):Void {
		__previousEnabled = flag == "true" ? true : false;
	}
	function get previousEnabled():Boolean {
		return __previousEnabled;
	}
	
	public function setPreviousEnabled(flag:Boolean):Void {
		__previousEnabled = flag == "true" ? true : false;
	}
	public function getPreviousEnabled():Boolean {
		return __previousEnabled;
	}
	
	[Inspectable(defaultValue="Final Assessment" type="String")]
	function set titleTxt(val:String):Void {
		__titleTxt = val;
		tTxt.text = __titleTxt;
	}
	function get titleTxt():String {
		return __titleTxt;
	}
	
	public function setTitleTxt(val:String):Void {
		__titleTxt = val;
		tTxt.text = __titleTxt;
		
	}
	public function getTitleTxt():String {
		return __titleTxt;
	}
	
	
	[Inspectable(enumeration="true,false", defaultValue="true" type="String")]
	function set showFeedback(flag:String):Void {
		__showFeedback = flag == "true" ? true : false;
	}
	function get showFeedback():Boolean {
		return __showFeedback;
	}
	
	public function setShowFeedback(flag:Boolean):Void {
		__showFeedback = flag;
	}
	public function getShowFeedback():Boolean {
		return __showFeedback;
	}
	
	
	[Inspectable(enumeration="left,center,right", defaultValue="right" type="String")]
	function set promptAlign(str:String):Void {
		__promptAlign = str;
	}
	function get promptAlign():String {
		return __promptAlign;
	}
	
	public function setPromptAlign(str:String):Void {
		__promptAlign = str;
	}
	public function getPromptAlign():String {
		return __promptAlign;
	}
	
	[Inspectable(defaultValue=75 type="Number")]
	function set passPercentage(val:Number):Void {
		__passPercentage = val;
	}
	function get passPercentage():Number {
		return __passPercentage;
	}
	
	public function setPassPercentage(val:Number):Void {
		__passPercentage = val;
	}
	public function getPassPercentage():Number {
		return __passPercentage;
	}
	
}