﻿import com.trina.utils.CustomButton;
import com.trina.parser.XMLParser;

class com.trina.assessments.DragNDrop extends com.trina.assessments.AssessmentsBase {
	private var myObj:Object;
	private var dragmcArray:Array;
	private var targetmcArray:Array;
	private var submitBtn:CustomButton;
	private var correctAnswerCount:Number;
	private var feedbackTxt:TextField;
	private var backdropMC:MovieClip;
	
	function DragNDrop() {
		this.onLoad = function () {
			initDragNDrop();
		}
	}
	
	public function initDragNDrop() {
		backdropMC._visible = false;
		loadXML();
	}
	
	// temporary for practice assessment
	public function loadXML() {
		var file = _global.getContentPath() + _parent._parent.getTemplateXMLFile();
		
		//file = "../module02/xml/m02l02t03p01.xml";
		//XMLParser.initializeSingleton();
		
		var xp:XMLParser = XMLParser.getInstance();
		xp.readXML(file, "handleXMLLoad", this);
		
		delete file;
		delete xp;	
	
	}
	
	public function handleXMLLoad(obj:Object) {
		myObj = obj.DragNDrop;
		
		submitBtn._visible = false;
		
		var nObj = _parent._parent.getDetails();
		var t = "Question " + getString(nObj.currentQuestion) + " of " + getString(nObj.totalQuestions);
		//setTitle(t);
		setQuestion(myObj.QuestionTxt._value);
		feedbackTxt.htmlText = myObj.instructionText._value;
		dragmcArray = new Array();
		targetmcArray = new Array();
		var depth = 1;
		
		var len = myObj.Targets.Target.length;
		for (var k = 0; k < len; k++) {
			var tempObj:Object = new Object();
			tempObj.label = myObj.Targets.Target[k].Text._value;
			tempObj.index = k + 1;
			tempObj.id = myObj.Targets.Target[k].id;
			var mc = this.attachMovie("TargetItem", "tt" + k, depth++, {sObj:tempObj});
			mc._visible = false;
			targetmcArray.push(mc);
		}
		
		var len = myObj.Drags.Drag.length;
		for (var k = 0; k < len; k++) {
			var tempObj:Object = new Object();
			tempObj.label = myObj.Drags.Drag[k].Text._value;
			tempObj.index = k;
			tempObj.targetIndex = Number(myObj.Drags.Drag[k].target) - 1;
			tempObj.id = myObj.Drags.Drag[k].id;
			var mc = this.attachMovie("DragItem", "dd" + k, depth++, {sObj:tempObj});
			mc._visible = false;
			dragmcArray.push(mc);
		}
		
			
	}
	
	public function handleCallBack(num:Number) {
		if (num == myObj.Drags.Drag.length) {
			reArrangeElements();
		}
	}
	
	public function reArrangeElements() {
		var xPos = myObj.Config.xPos == undefined ? 20 : Number(myObj.Config.xPos);
		var yPos = questionTxt._y + questionTxt.textHeight + 80;
		var gap = myObj.Config.gap == undefined ? 9 : Number(myObj.Config.gap);
		
		var len = dragmcArray.length;
		for (var k = 0; k < len; k++) {
			var pos = k == 0 ? yPos : ((dragmcArray[k - 1]._y + dragmcArray[k - 1]._height) + gap);
			dragmcArray[k]._x = xPos;
			dragmcArray[k]._y = pos;
			dragmcArray[k]._visible = true;
			dragmcArray[k].setPosition();
			
		}
		
		var len = targetmcArray.length;
		for (var k = 0; k < len; k++) {
			var pos = k == 0 ? yPos : ((targetmcArray[k - 1]._y + targetmcArray[k - 1]._height) + gap);
			targetmcArray[k]._x = xPos + dragmcArray[0]._width + 40;
			targetmcArray[k]._y = pos;
			targetmcArray[k]._visible = true;
		}
		
		backdropMC._x = targetmcArray[0]._x - 5;
		backdropMC._y = yPos - 5;
		backdropMC._visible = true;
		
		//submitBtn._y = dragmcArray[dragmcArray.length - 1]._y + dragmcArray[dragmcArray.length -1]._height + 30;
		submitBtn.initButton("VERIFY", "handleSubmit", this, 0x000000, 0x000000, 0, "", false);
		submitBtn._visible = true;
		//feedbackTxt._y = submitBtn._y + submitBtn._height + 40;
		
	}
	
	
	
	public function handleSubmit() {
		correctAnswerCount = 0;
		var len = dragmcArray.length;
		for (var k = 0; k < len; k++) {
			var dragMC:MovieClip = this["dd" + k];
			if(dragMC.getPlacedOnIndex() == dragMC.getCorrectTarget()){
				correctAnswerCount++
				dragMC.changeState(false);
			}else{
				dragMC.animateToOriginalPos();
			}
			
		}
		if (correctAnswerCount == len) {
			feedbackTxt.htmlText = myObj.feedBacks.correctFeedback._value;
			makeOptionButtonsState(false);
			break;
		} else {

			feedbackTxt.htmlText = myObj.feedBacks.incorrectFeedback._value;
		}
		submitBtn.changeState(false);
	}
	
	public function makeOptionButtonsState(flag) {
		var len = dragmcArray.length;
		for (var k = 0; k < len; k++) {
			dragmcArray[k].changeState(flag);
		}
	}
	
	private function getString(num:Number):String {
		var str = num < 10 ? ("0" + num) : ("" + num);
		return str;
	}
	
	public function startDragging(clipID:MovieClip){
		clipID.swapDepths(this.getNextHighestDepth())
		clipID.startDrag(false)
		
	}
	
	public function checkTarget(clipID:MovieClip){
		clipID.stopDrag()
		var animateToOrig:Boolean = true;
		//--- if the clip has been dropped into any of the target then leave it there
		//--- otherwise revert back to its original position
		var dropTarget:MovieClip = eval(clipID._droptarget)
		var len = targetmcArray.length;
		for (var k = 0; k < len; k++) {
			if(dropTarget == this["tt" + k].targetBox){
				clipID._x = dropTarget._parent._x;
				clipID._y = dropTarget._parent._y;
				animateToOrig = false;	
				clipID.setPlacedOnIndex(k);
				submitBtn.changeState(true);
			}
		}
		if(animateToOrig){
			clipID.animateToOriginalPos();
		}
	}
}