﻿class com.trina.assessments.dragnorder.DragItem extends com.trina.utils.AniMovieClip {
	private var labelTxt:TextField;
	private var sObj:Object;
	private var isAnimating:Boolean = false;
	private var posObj:Object;
	private var posIndex:Number;
	private var numOfCallBack:Number = 0;
	private var xend:Number;
	private var yend:Number;
	
	function DragItem() {
		this.onLoad = function () {
			init();
		}
	}
	
	private function init() {
		posObj = new Object();
		posObj.x = this._x;
		posObj.y = this._y;
		
		labelTxt.autoSize = "left";
		var str1 = '<P Align="' + sObj.align + '">';
		var str2 = '</P>';
		labelTxt.htmlText = str1 + sObj.label + str2;
		//labelTxt.htmlText = sObj.label;
		this.onPress = function(){
			if (!isAnimating) {
				_parent.startDragging(this);
			}
		}
		this.onRelease = function () {
			_parent.checkTarget(this);
		}
		
		_parent.handleCallBack(sObj.index);
	}
	public function getCorrectTarget(){
		return sObj.targetIndex;
	}
	
	public function changeState(flag:Boolean) {
		this.enabled = flag;
		this._alpha = flag ? 100 : 60; 
	}
	
	public function getPosIndex() {
		return posIndex;
	}
	
	public function setPosIndex(num:Number) {
		posIndex = num;
		sObj.index = num;
	}
	
	public function setPosition(){
		sObj.xPos = this._x;
		sObj.yPos = this._y;
		posObj.x = sObj.xPos;
		posObj.y = sObj.yPos;
	}
	
	public function getPosition() {
		return posObj;
	}
	
	public function setPlacedOnIndex(clipIndex:Number){
		sObj.placedOn = clipIndex;
	}
	public function getPlacedOnIndex(){
		return sObj.placedOn;
	}
	
	public function getIndex() {
		return sObj.index;
	}
	
	public function animateToOriginalPos() {
		var obj:Object = new Object();
		obj.xBegin = this._x;
		obj.xEnd = sObj.xPos;
		obj.yBegin = this._y;
		obj.yEnd = sObj.yPos;
		obj.duration = .5;

		xend = obj.xEnd;
		yend = obj.yEnd;
		isAnimating = true;
		this.animate(obj);
	
	}
	
	public function animateToPos(x, y) {
		var obj:Object = new Object();
		obj.xBegin = this._x;
		obj.xEnd = x;
		obj.yBegin = this._y;
		obj.yEnd = y;
		obj.duration = .1;
		xend = obj.xEnd;
		yend = obj.yEnd;
		
		
		isAnimating = true;
		this.animate(obj);
		
	
	}
	
	public function handleAnimationCallBack() {
		isAnimating = false;
		posObj.x = xend;
		posObj.y = yend;
		sObj.xPos = xend;
		sObj.yPos = yend;
	}
	
	
	
}