﻿import com.trina.utils.CustomButton;
import com.trina.parser.XMLParser;

class com.trina.assessments.dragnorder.DragNOrder extends com.trina.assessments.AssessmentsBase {
	private var myObj:Object;
	private var dragmcArray:Array;
	private var configObj:Object;
	private var targetmcArray:Array;
	private var submitBtn:CustomButton;
	private var correctAnswerArray:Array;
	private var feedbackTxt:TextField;
	private var numberOfTries:Number;
	private var attempted:Number;
	
	function DragNOrder() {
		this.onLoad = function () {
			initDragNDrop();
		}
	}
	
	public function initDragNDrop() {
		configObj = _parent._parent.getConfigObject();
		loadXML();
	}
	
	// temporary for practice assessment
		
	public function handleXMLLoad(obj:Object) {
		myObj = obj.Data;
		
		submitBtn._visible = false;
		attempted = 0;
		if (configObj.showId) {
			setId(configObj.idText);
		} else {
			setId("");
		}
		
		
		//setTitle(t);
		setQuestion(myObj.QuestionTxt._value);
		numberOfTries = Number(myObj.Config.numberOfTry);
		
		feedbackTxt.htmlText = myObj.instructionText._value;
		dragmcArray = new Array();
		targetmcArray = new Array();
		var depth = 1;
		
		/*
		var len = myObj.Targets.Target.length;
		for (var k = 0; k < len; k++) {
			var tempObj:Object = new Object();
			tempObj.label = myObj.Targets.Target[k].Text._value;
			tempObj.index = k + 1;
			tempObj.id = myObj.Targets.Target[k].id;
			var mc = this.attachMovie("TargetItem", "tt" + k, depth++, {sObj:tempObj});
			mc._visible = false;
			targetmcArray.push(mc);
		}
		*/
		correctAnswerArray = new Array();
		var len = myObj.Drags.Drag.length;
		for (var k = 0; k < len; k++) {
			var tempObj:Object = new Object();
			tempObj.label = myObj.Drags.Drag[k].Text._value;
			tempObj.index = k;
			tempObj.id = myObj.Drags.Drag[k].id;
			tempObj.targetIndex = Number(myObj.Drags.Drag[k].target);
			tempObj.align = myObj.Config.align;
			correctAnswerArray.push(tempObj.targetIndex);
			
			var mc = this.attachMovie("DragItem", "dd" + k, depth++, {sObj:tempObj});
			mc._visible = false;
			dragmcArray.push(mc);
		}
		
			
	}
	
	public function handleCallBack(num:Number) {
		if (num == myObj.Drags.Drag.length - 1) {
			reArrangeElements();
		}
	}
	
	public function reArrangeElements() {
		var xPos = myObj.Config.xPos == undefined ? 0 : Number(myObj.Config.xPos);
		var yPos = questionTxt._y + questionTxt.textHeight + 25;
		var gap = myObj.Config.gap == undefined ? 9 : Number(myObj.Config.gap);
		
		var len = dragmcArray.length;
		for (var k = 0; k < len; k++) {
			var pos = k == 0 ? yPos : (yPos + (gap * k));
			dragmcArray[k]._x = xPos;
			dragmcArray[k]._y = pos;
			dragmcArray[k]._visible = true;
			dragmcArray[k].setPosition();
			dragmcArray[k].setPosIndex(k);
			
		}
		/*
		var len = targetmcArray.length;
		for (var k = 0; k < len; k++) {
			var pos = k == 0 ? yPos : ((targetmcArray[k - 1]._y + targetmcArray[k - 1]._height) + gap);
			targetmcArray[k]._x = xPos + dragmcArray[0]._width + 40;
			targetmcArray[k]._y = pos;
			targetmcArray[k]._visible = true;
		}
		*/
		
		
		//submitBtn._y = dragmcArray[dragmcArray.length - 1]._y + dragmcArray[dragmcArray.length -1]._height + 30;
		submitBtn.initButton("CHECK", "handleSubmit", this, 0x000000, 0xFFFFFF, 0, "", false);
		submitBtn._visible = true;
		//feedbackTxt._y = submitBtn._y + submitBtn._height + 40;
		
	}
	
	private function showFeedback(str:String, col:String) {
		var str1 = '<FONT Color="' + col + '">';
		var str2 = '</FONT>';
		feedbackTxt.htmlText = str1 + str + str2;
	}
	
	public function handleSubmit() {
		attempted++;
		var len = dragmcArray.length;
		
		var correct = true;
		var correctAns = 0;
		for (var k = 0; k < len; k++) {
			if (dragmcArray[k].getPosIndex() + 1 == dragmcArray[k].getCorrectTarget()) {
				correctAns++;
			} else {
				correct = false;
				break;
			}
			
		}
		
		if (correctAns == len) {
			
		} else {
			correct = false;
		}
		
		if (correct) {
			if (configObj.showFeedback) {
				showFeedback(myObj.correctFeedback._value, configObj.correctColor);
			}
		} else {
			if (configObj.showFeedback) {
				if (attempted == numberOfTries) {
					showFeedback(myObj.incorrectFeedbackLast._value, configObj.incorrectColor);
				} else {
					showFeedback(myObj.incorrectFeedback._value, configObj.incorrectColor);
				}
			}
		}
		submitBtn.changeState(false);
		if (attempted == numberOfTries) {
			makeOptionButtonsState(false);
			submitBtn.changeState(false);
			if (!correct) {
				showCorrectAnswer();
			}
		}
		if (correct) {
			makeOptionButtonsState(false);
			submitBtn.changeState(false);
		}
		_parent._parent.setNextButtonState(true);
		_parent._parent.setAnswer(configObj.scoreValue, correct);
	}
	
	public function showCorrectAnswer() {
		
	}
	
	
	public function makeOptionButtonsState(flag) {
		var len = dragmcArray.length;
		for (var k = 0; k < len; k++) {
			dragmcArray[k].changeState(flag);
		}
	}
	
	private function getString(num:Number):String {
		var str = num < 10 ? ("0" + num) : ("" + num);
		return str;
	}
	
	public function startDragging(clipID:MovieClip){
		clipID.swapDepths(this.getNextHighestDepth())
		clipID.startDrag(false);
		
	}
	
	public function checkTarget(clipID:MovieClip){
		clipID.stopDrag()
		var animateToOrig:Boolean = true;
		//--- if the clip has been dropped into any of the target then leave it there
		//--- otherwise revert back to its original position
		var dropTarget:MovieClip = eval(clipID._droptarget);
		if (dropTarget._name == "labelTxt" || dropTarget._name == "bgmc") {
			dropTarget = dropTarget._parent;
		}
		if (dropTarget == undefined) {
			clipID.animateToOriginalPos();
		} else {
			var obj1 = dropTarget.getPosition();
			var obj2 = clipID.getPosition();
			if (obj1.x == undefined || obj1.y == undefined || obj2.x == undefined || obj2.y == undefined) {
				clipID.animateToOriginalPos();
				return;
			}
			
			clipID.animateToPos(obj1.x, obj1.y);
			dropTarget.animateToPos(obj2.x, obj2.y);
			
			var dPosIndex = clipID.getPosIndex();
			var tPosIndex = dropTarget.getPosIndex();
			
			dragmcArray[dPosIndex] = dropTarget;
			dragmcArray[tPosIndex] = clipID;
			dropTarget.setPosIndex(dPosIndex);
			clipID.setPosIndex(tPosIndex);
			submitBtn.changeState(true);
		}
		
	}
}
