﻿import com.trina.utils.CustomButton;
import mx.containers.ScrollPane;

class com.trina.assessments.hotspot.HotSpot extends com.trina.assessments.AssessmentsBase {
	
	private var configObj:Object;
	private var myObj:Object;
	private var feedbackTxt:TextField;
	private var numberOfTries:Number;
	private var attempted:Number; 
	private var myPane:ScrollPane;
	private var panemc:MovieClip;
	private var imageHolder:MovieClip;
	private var submitBtn:CustomButton;
	private var mcArray:Array;
	private var correctHotspot:Number;
	private var selectedItem:Number;
	private var rippleMC:MovieClip;
	private var isCorrect:Boolean;
	private var blankMC:MovieClip;
	private var startX:Number;
	private var startY:Number;
	
	
	
	function HotSpot() {
		this.onLoad = function () {
			initHotSpot();
		}
	}
	
	public function initHotSpot() {
		startX = 20;
		startY = 65
		configObj = _parent._parent.getConfigObject();
		if (configObj == undefined) {
			configObj = new Object();
			configObj.showId = false;
			configObj.idText = "";
			configObj.showFeedback = true;
			configObj.correctColor = "#006600";
			configObj.incorrectColor = "#CC0000";
			configObj.scoreValue = 1;
			configObj.isAssessment = false;
		}
		loadXML();
	}
	
	private function makeProperArray() {
		var len = myObj.hotspots.hotspot.length;
		if (len == undefined) {
			var arr:Array = new Array();
			var obj = myObj.hotspots.hotspot;
			arr.push(obj);
			myObj.hotspots.hotspot = arr;
			
		}
	}
	
	public function handleImageLoaded() {
		blankMC._width = imageHolder._width;
		blankMC._height = imageHolder._height;
	}
	public function handleXMLLoad(obj:Object) {
		
		myObj = obj.Data;
		makeProperArray();
		
		feedbackTxt.autoSize = "left";
		feedbackTxt.htmlText = "";
		submitBtn._visible = false;
		attempted = 0;
		
		if (configObj.showId) {
			setId(configObj.idText);
		} else {
			setId("");
		}
		setQuestion(myObj.question._value);
		numberOfTries = Number(myObj.hotspots.numberOfTry);
		
		myPane._visible = false;
		myPane.setStyle("borderStyle", "none")
		myPane.contentPath = "holderMC";
		panemc = myPane.content;
		mcArray = new Array();
		var optionsLen = myObj.hotspots.hotspot.length;
		
		
		//imageHolder = panemc.attachMovie("ImageHolderMC", "imgHolder", panemc.getNextHighestDepth());
		imageHolder = this.attachMovie("ImageHolderMC", "imgHolder", this.getNextHighestDepth());
		imageHolder.loadImage(myObj.image._value);
		imageHolder._x = myObj.image.xPos != undefined ? Number(myObj.image.xPos) : startX;
		imageHolder._y = startY;
		blankMC = this.attachMovie("blankMC", "mcaa", this.getNextHighestDepth());
		blankMC._alpha = 0;
		blankMC._x = imageHolder._x;
		blankMC._y = imageHolder._y;
		
		blankMC.onPress = function () {
			_parent.showHighlight(this._parent._xmouse, this._parent._ymouse);
		}
		
		for (var k = 0; k < optionsLen; k++) {
			var hObj:Object = new Object();
			hObj = myObj.hotspots.hotspot[k];
			hObj.num = k + 1;
			if (hObj.answer == true || hObj.answer) {
				correctHotspot = Number(hObj.id);
			}
			
			hObj.normalColor = myObj.normalcolor._value;
			hObj.rollColor = myObj.rollcolor._value;
			hObj.selectedColor = myObj.selectedcolor._value;
			
			
			
			if (hObj.type == "circle") {
				var rmc = this.attachMovie("OutCircle", "cl" + (k + 1), this.getNextHighestDepth(), {myObj:hObj});
				rmc._x = startX + Number(hObj.x._value);
				rmc._y = startY + Number(hObj.y._value);
				rmc._width = 2 * Number(hObj.radius._value);
				rmc._height = 2 * Number(hObj.radius._value);
				mcArray.push(rmc);
			} else if (hObj.type == "rectangle") {
				var rmc = panemc.attachMovie("Outline", "cl" + (k + 1), this.getNextHighestDepth(), {myObj:hObj});
				rmc._x = startX + Number(hObj.x._value);
				rmc._y = startY + Number(hObj.y._value);
				rmc._width = 2 * Number(hObj.w._value);
				rmc._height = 2 * Number(hObj.h._value);
				mcArray.push(rmc);
			}
			
			mcArray.push(rmc);
			
		}
		
		
		refreshUI();
	}
	
	public function showHighlight(x:Number, y:Number) {
		isCorrect = false;
		rippleMC.removeMovieClip();
		rippleMC = this.attachMovie("hot_s", "ripple", this.getNextHighestDepth());
		rippleMC._x = x;
		rippleMC._y = y;
		submitBtn.changeState(true);
		
	}
	
	private function refreshUI() {
		myPane.redraw();
		myPane._visible = true;
		submitBtn.initButton("Submit", "handleSubmit", this, 0xFFFFFF, 0x000000, 0, "", false);
		submitBtn._visible = true;
	}
	
	public function handleHotSpotSelection(num:Number, optionId:String, mc:MovieClip) {
		isCorrect = true;
		rippleMC.removeMovieClip();
		rippleMC = this.attachMovie("hot_s", "ripple", this.getNextHighestDepth());
		rippleMC._x = mc._x;
		rippleMC._y = mc._y;
		submitBtn.changeState(true);
		
		//makeOptionButtonsSelection(false);
		//mc.setSelection(true);
		//selectedItem = num;
		
	}
	
	private function showFeedback(str:String, col:String) {
		var str1 = '<FONT Color="' + col + '">';
		var str2 = '</FONT>';
		feedbackTxt.htmlText = str1 + str + str2;
	}
	
	public function handleSubmit() {
		
		attempted++;
		submitBtn.changeState(false);
		var correct = false;
		if (isCorrect) {
			correct = true;
			if (configObj.showFeedback) {
				showFeedback(myObj.correctFeedback._value, configObj.correctColor);
			}
		} else {
			if (configObj.showFeedback) {
				if (attempted == numberOfTries) {
					showFeedback(myObj.incorrectFeedbackLast._value, configObj.incorrectColor);
				} else {
					showFeedback(myObj.incorrectFeedback._value, configObj.incorrectColor);
				}
			}
		}
		if (attempted == numberOfTries) {
			delete blankMC.onPress;
			makeOptionButtonsState(false);
			submitBtn.changeState(false);
			if (!correct) {
				showCorrectAnswer();
			}
		}
		if (correct) {
			makeOptionButtonsState(false);
			submitBtn.changeState(false);
		}
		_parent._parent.setNextButtonState(true);
		_parent._parent.setAnswer(configObj.scoreValue, correct);
	}
	
	
	public function showCorrectAnswer() {
		
	}
	
	public function showCorrectAnswer() {
		
	}
	
	public function makeOptionButtonsState(flag) {
		var len = mcArray.length;
		for (var k = 0; k < len; k++) {
			mcArray[k].changeState(flag);
		}
	}
	public function makeOptionButtonsSelection(flag) {
		var len = mcArray.length;
		for (var k = 0; k < len; k++) {
			mcArray[k].setSelection(flag);
		}
	}
}
