﻿import com.trina.utils.CustomButton;
import com.trina.utils.ImageHolder;

class com.trina.assessments.singlemultiselect.SingleMultiSelect extends com.trina.assessments.AssessmentsBase {
	private var myObj:Object;
	private var mcArray:Array;
	
	private var submitBtn:CustomButton;
	private var selectedItem:Array;
	private var feedbackTxt:TextField;
	private var configObj:Object;
	private var correctAnswer:Array;
	private var numberOfTries:Number;
	private var attempted:Number;
	private var mId:Number;
	private var imageHolder:ImageHolder;
	private var qbg:MovieClip;
	private var imagebg:MovieClip;
	private var qId:Number;
	private var backdropMC:MovieClip;
	private var questionAudio:Sound;
	private var correctFeedbackAudio:Sound;
	private var incorrectFeedbackAudio:Sound;
	private var incorrectFeedbackLastAudio:Sound;
	
	
	
	function SingleMultiSelect() {
		this.onLoad = function () {
			initSingleSelect();
		}
	}
	
	public function initSingleSelect() {
		clearInterval(qId);
		submitBtn._visible = false;
		backdropMC._visible = false;
		backdropMC.gotoAndStop(1);
		configObj = _parent._parent.getConfigObject();
		if (configObj == undefined) {
			configObj = new Object();
			configObj.showId = false;
			configObj.idText = "";
			configObj.showFeedback = true;
			configObj.correctColor = "#006600";
			configObj.incorrectColor = "#CC0000";
			configObj.scoreValue = 1;
			configObj.isAssessment = false;
		}
		loadXML();
	}
	
	public function handleXMLLoad(obj:Object) {
		imageHolder.unloadImage();
		myObj = obj.Data;
		feedbackTxt.htmlText = _parent._parent.getPagePrompt();
		submitBtn._visible = false;
		backdropMC._visible = false;
		attempted = 0;
		
		if (configObj.showId) {
			setId(configObj.idText);
		} else {
			setId("");
		}
		
		setQuestion(myObj.QuestionTxt._value);
		numberOfTries = Number(myObj.Options.numberOfTry);
		
		mcArray = new Array();
		correctAnswer = new Array;
		selectedItem = new Array();
		if (myObj.Options.correctAns.length > 1) {
			correctAnswer = myObj.Options.correctAns.split(",");
			var len = correctAnswer.length;
			for (var k = 0; k < len; k++) {
				correctAnswer[k] = Number(correctAnswer[k]);
			}
		} else {
			correctAnswer = new Array();
			correctAnswer.push(Number(myObj.Options.correctAns))
		}
		var len = myObj.Options.Option.length;
		var isRandomize = myObj.Options.isRandomized == "true" ? true : false;
		if (isRandomize) {
			myObj.Options.Option = randomizeArray(myObj.Options.Option);
		}
		var qIdArray = new Array("A", "B", "C", "D", "E", "F", "G");
		for (var k = 0; k < len; k++) {
			var tempObj:Object = new Object();
			tempObj = myObj.Options.Option[k];
			tempObj.qId = qIdArray[k];
			if (correctAnswer.length > 1) {
				var mc = this.attachMovie("MultiSelectItem", "sl" + k, k + 1, {sObj:tempObj});
			} else {
				var mc = this.attachMovie("SingleSelectItem", "sl" + k, k + 1, {sObj:tempObj});
			}
			mc._visible = false;
			mcArray.push(mc);
		}
		if (myObj.QuestionImage != undefined) {
			imageHolder.loadImage(_root.getSelectedPath() + myObj.QuestionImage.src);
			if (myObj.QuestionImage.xPos != undefined) {
				imageHolder._x = myObj.QuestionImage.xPos;
			}
			if (myObj.QuestionImage.yPos != undefined) {
				imageHolder._y = myObj.QuestionImage.yPos;
			}
			imagebg._visible = true;
		} else {
			imageHolder._visible = false;
			imagebg._visible = false;
		}
		setupKeyBoardInteractions(len);
	}
	
	public function setupKeyBoardInteractions(num:Number) {
		var keyArray1 = new Array("A", "B", "C", "D", "E", "F");
		var keyArray2 = new Array("a", "b", "c", "d", "e", "f");
		
		var lent = keyArray1.length;
		var lenr = keyArray2.length;
		this.onKeyDown = function () {
			if(Key.getCode() == Key.ENTER){
				submitBtn.showRollOver();
			}
			for (var k = 0; k < lent; k++) {
				if(chr(Key.getAscii()) == keyArray1[k] || chr(Key.getAscii()) == keyArray2[k]) {
					mcArray[k].showState(true);
					break;
				}
				
			}
			
		}
		this.onKeyUp = function(){
			if(Key.getCode() == Key.ENTER){
				submitBtn.handleRelease();
			}
			for (var k = 0; k < lent; k++) {
				if(chr(Key.getAscii()) == keyArray1[k] || chr(Key.getAscii()) == keyArray2[k]) {
					mcArray[k].showState(false);
					var state = mcArray[k].getSelection();
					handleOptionSelection(k + 1, state);
					break;
				}
				
			}
		}
		
		
		Key.addListener(this);
		
	}
	
	public function handleCallBack(num:Number) {
		if (num == myObj.Options.Option.length) {
			mId = setInterval(this, "reArrangeElements", 100);
		}
	}
	
	public function reArrangeElements() {
		clearInterval(mId);
		qbg._height = questionTxt.textHeight + 15;
		var xPos = 0;
		var yPos = qbg._y + qbg._height + 25; //questionTxt._y + questionTxt.textHeight + 25;
		var gap = 10;
		
		
		
		var len = mcArray.length;
		for (var k = 0; k < len; k++) {
			var pos = k == 0 ? yPos : ((mcArray[k - 1]._y + mcArray[k - 1]._height) + gap);
			mcArray[k]._x = xPos;
			mcArray[k]._y = pos;
			mcArray[k]._visible = true;

		}
		
		submitBtn._y = mcArray[mcArray.length - 1]._y + mcArray[mcArray.length -1]._height + 50;
		submitBtn.initButton("Submit", "handleSubmit", this, 0xFFFFFF, 0x000000, 0, "", false);
		submitBtn._visible = true;
		backdropMC._visible = true;
		backdropMC._y = submitBtn._y + 10;
		feedbackTxt._y = submitBtn._y + 20;
		feedbackTxt.autoSize = "left";
		
		initiateSounds();
	}
	
	private function initiateSounds() {
		questionAudio = new Sound();
		correctFeedbackAudio = new Sound();
		incorrectFeedbackAudio = new Sound();
		incorrectFeedbackLastAudio = new Sound();
		var refObj:Object = this;
		
		questionAudio.onLoad = function (success) {
			if (success) {
				refObj.startQuestionAudio();
			}
		}
		questionAudio.onSoundComplete = function () {
			// do what now?
		}
		
		correctFeedbackAudio.onSoundComplete = function () {
			refObj.CallNextQuestion();
		}
		
		incorrectFeedbackAudio.onSoundComplete = function () {
			refObj.CallNextQuestion();
		}
		
		incorrectFeedbackLastAudio.onSoundComplete = function () {
			refObj.CallNextQuestion();
		}
		
		questionAudio.loadSound(_root.getSelectedPath() + myObj.QuestionTxt.audioSrc);
		
		correctFeedbackAudio.loadSound(_root.getSelectedPath() + myObj.correctFeedbackAudio.audioSrc);
		incorrectFeedbackAudio.loadSound(_root.getSelectedPath() + myObj.incorrectFeedbackAudio.audioSrc);
		incorrectFeedbackLastAudio.loadSound(_root.getSelectedPath() + myObj.incorrectFeedbackLastAudio.audioSrc);
		
	}
	
	private function startQuestionAudio() {
		questionAudio.start();
	}
	
	public function handleOptionSelection(num:Number, flag:Boolean) {
		
		var len = mcArray.length;
		if (correctAnswer.length > 1) {
			var nowSelected = flag ? false : true;
			selectedItem[num - 1] = nowSelected;
			for (var k = 0; k < len; k++) {
				if (num == mcArray[k].getIndex()) {
					mcArray[k].setSelection(nowSelected);
				}
			}
			
		} else {
			selectedItem[0] = num;
			for (var k = 0; k < len; k++) {
				if (num == mcArray[k].getIndex()) {
					mcArray[k].setSelection(true);
				} else {
					mcArray[k].setSelection(false);
				}
			}
		}
		submitBtn.changeState(true);
		backdropMC.gotoAndStop(2);
	}
	
	private function showFeedbackNew(num:Number) {
		var str = _parent._parent.getWaitingInstruction();
		feedbackTxt.htmlText = str;
		if (num == 1) {
			correctFeedbackAudio.start();
		} else if (num == 2) {
			incorrectFeedbackAudio.start();
		} else if (num == 3) {
			incorrectFeedbackLastAudio.start();
		}
		
		clearInterval(qId);
		qId = setInterval(this, "CallNextQuestion", 1000);
		
	}
	
	public function CallNextQuestion() {
		correctFeedbackAudio.stop();
		incorrectFeedbackAudio.stop();
		incorrectFeedbackLastAudio.stop();
		clearInterval(qId);
		_parent._parent.handleNext();
	}
	
	public function handleSubmit() {
		questionAudio.stop();
		attempted++;
		var correct = false;
		if (correctAnswer.length > 1) {
			var len = correctAnswer.length;
			var bool = true;
			var totalTrue = 0;
			for (var k = 0; k < len; k++) {
				if (selectedItem[correctAnswer[k] - 1] != true) {
					bool = false;
					
				}
			}
			var len = selectedItem.length;
			for (var k = 0; k < len; k++) {
				if (selectedItem[k]) {
					totalTrue++;
				}
			}
			if (correctAnswer.length != totalTrue) {
				bool = false;
			}
			
		} else {
			if (selectedItem[0] == myObj.Options.correctAns) {
				correct = true;
			} else {
				
			}
		}
		submitBtn.changeState(false);
		if (attempted == numberOfTries) {
			makeOptionButtonsState(false);
			submitBtn.changeState(false);
			
			if (!correct) {
				showCorrectAnswer();
			}
		}
		var num = 1;
		if (correct) {
			num = 1;
		} else {
			if (attempted == numberOfTries) {
				num = 3;
			} else {
				num = 2;
			}
		}
		showFeedbackNew(num);
		_parent._parent.setAnswer(configObj.scoreValue, correct);
		_parent._parent.setNextButtonState(true);
		
	}
	
	public function showCorrectAnswer() {
		if (configObj.isAssessment) {
			return;
		}
		var len = mcArray.length;
		for (var k = 0; k < len; k++) {
			mcArray[k].setSelection(false);
			
			for (var i = 0; i < correctAnswer.length; i++) {
				
				if (mcArray[k].getIndex() == correctAnswer[i]) {
					mcArray[k].setSelection(true);
					break;
				}
			}
		}
		
		
	}
	
	public function makeOptionButtonsState(flag) {
		var len = mcArray.length;
		for (var k = 0; k < len; k++) {
			mcArray[k].changeState(flag);
		}
	}
	
	private function getString(num:Number):String {
		var str = num < 10 ? ("0" + num) : ("" + num);
		return str;
	}
	
	private function randomizeArray(arr:Array) {
		
		for (var k = 0; k < 3; k++) {
			var len = arr.length;
			for (var x = 0; x < len; x++) {
				var ran = Random(len);
				var a = arr[ran];
				arr.splice(ran, 1);
				arr.push(a);
			}
		}
		return arr;
	}
	

}