﻿import com.trina.utils.CustomButton;
import com.trina.parser.XMLParser;

class com.trina.assessments.singleselectimage.SingleSelectImage extends com.trina.assessments.AssessmentsBase {
	private var myObj:Object;
	private var mcArray:Array;
	private var submitBtn:CustomButton;
	private var selectedItem:Number;
	private var feedbackTxt:TextField;
	private var configObj:Object;
	private var numberOfTries:Number;
	private var attempted:Number;
	
	
	function SingleSelectImage() {
		this.onLoad = function () {
			initSingleSelect();
		}
	}
	
	public function initSingleSelect() {
		configObj = _parent._parent.getConfigObject();
		if (configObj == undefined) {
			configObj = new Object();
			configObj.showId = false;
			configObj.idText = "";
			configObj.showFeedback = true;
			configObj.correctColor = "#006600";
			configObj.incorrectColor = "#CC0000";
			configObj.scoreValue = 1;
			configObj.isAssessment = false;
		}
		loadXML();
	}
	
	
	
	public function handleXMLLoad(obj:Object) {
		myObj = obj.SingleSelectImage;
		//feedbackTxt.htmlText = "Click <b>VERIFY</b> after you are done.";
		submitBtn._visible = false;
		
		var nObj = _parent._parent.getDetails();
		var t = "Question " + getString(nObj.currentQuestion) + " of " + getString(nObj.totalQuestions);
		if (configObj.showId) {
			setId(configObj.idText);
		} else {
			setId("");
		}
		numberOfTries = Number(myObj.Options.numberOfTry);
		setQuestion(myObj.QuestionTxt._value);
		mcArray = new Array();
		var len = myObj.Options.Option.length;
		for (var k = 0; k < len; k++) {
			var tempObj:Object = new Object();
			tempObj.label = myObj.Options.Option[k]._value;
			tempObj.image = myObj.Options.Option[k].src;
			tempObj.index = k + 1;
			var mc = this.attachMovie("SingleSelectItem", "sl" + k, k + 1, {sObj:tempObj});
			mc._visible = false;
			mcArray.push(mc);
		}
		attempted = 0;
	}
	
	public function handleCallBack(num:Number) {
		if (num == myObj.Options.Option.length) {
			reArrangeElements();
		}
	}
	
	public function reArrangeElements() {
		var xPos = 20;
		var yPos = questionTxt._y + questionTxt.textHeight + 80;
		var gap = 10;
		
		var len = mcArray.length;
		for (var k = 0; k < len; k++) {
			mcArray[k]._x = xPos + (mcArray[k]._width * k) + (gap * k);
			mcArray[k]._y = yPos;
			mcArray[k]._visible = true;
		}
		//submitBtn._y = yPos + mcArray[0]._height + 50;
		submitBtn.initButton("CHECK", "handleSubmit", this, 0x000000, 0xFFFFFF, 0, "", false);
		submitBtn._visible = true;
		//feedbackTxt._y = submitBtn._y + submitBtn._height + 40;
		//feedbackTxt.autoSize = true;
		feedbackTxt.htmlText = myObj.instructionText._value;
	}
	
	public function handleOptionSelection(num:Number) {
		var len = mcArray.length;
		selectedItem = num;
		
		for (var k = 0; k < len; k++) {
			if (k == num - 1) {
				mcArray[k].setSelection(true);
			} else {
				mcArray[k].setSelection(false);
			}
		}
		submitBtn.changeState(true);
	}
	
	private function showFeedback(str:String, col:String) {
		var str1 = '<FONT Color="' + col + '">';
		var str2 = '</FONT>';
		feedbackTxt.htmlText = str1 + str + str2;
	}
	
	public function handleSubmit() {
		attempted++;
		var correct = false;
		if (selectedItem == myObj.Options.correctAns) {
			if (configObj.showFeedback) {
				showFeedback(myObj.correctFeedback._value, configObj.correctColor);
			}
			correct = true;
		} else {
			if (attempted == numberOfTries) {
				showFeedback(myObj.incorrectFeedbackLast._value, configObj.incorrectColor);
			} else {
				showFeedback(myObj.incorrectFeedback._value, configObj.incorrectColor);
			}
			correct = false;
		}
		submitBtn.changeState(false);
		if (attempted == numberOfTries) {
			makeOptionButtonsState(false);
			submitBtn.changeState(false);
			if (!correct) {
				showCorrectAnswer();
			}
		}
		if (correct) {
			makeOptionButtonsState(false);
			submitBtn.changeState(false);
		}
		_parent._parent.setNextButtonState(true);
		_parent._parent.setAnswer(configObj.scoreValue, correct);
	}
	
	public function showCorrectAnswer() {
		if (configObj.isAssessment) {
			return;
		}
		var len = mcArray.length;
		for (var k = 0; k < len; k++) {
			mcArray[k].setSelection(false);
			
			
				if (k + 1 == myObj.Options.correctAns) {
					mcArray[k].setSelection(true);
					
				}
			
		}
		
		
	}
	
	public function makeOptionButtonsState(flag) {
		var len = mcArray.length;
		for (var k = 0; k < len; k++) {
			mcArray[k].changeState(flag);
		}
	}
	
	private function getString(num:Number):String {
		var str = num < 10 ? ("0" + num) : ("" + num);
		return str;
	}
	

}