﻿import mx.core.UIComponent;
class com.trina.components.AlertWin extends UIComponent{
	
	private var __title:String;
	private var __message:String;
	
	private var messageTxt;
	private var titleTxt;
	private var closeBtn:MovieClip;
	private var alertBox:MovieClip;
	private var obscurer:MovieClip;
	
	function init(){
		alertBox = this["alertBox"];
		messageTxt = alertBox.messageTxt;
		titleTxt = alertBox.titleTxt;
		closeBtn = alertBox.closeBtn;
		obscurer = this["obscurer"];
		
		obscurer._width = Stage.width;
		obscurer._height = Stage.height;
		
		alertBox._x = 18;//Stage.width/2 - alertBox._width/2;
		alertBox._y = 100;//Stage.height/2 - alertBox._height/2;
		obscurer._alpha = 0;
		
		setInteractions();
	}
	
	//Sets the alert box title
	private function setTitle(){
		titleTxt.htmlText = __title;
	}
	
	//Sets the message text
	private function setMessage(){
		messageTxt.htmlText = __message;
	}	
	
	//sets the interactiosn for the visual elements
	private function setInteractions():Void{
		var refObj:MovieClip = this;
		
		closeBtn.onRollOver = function(){
			this.gotoAndStop("rollOver");
		}
		
		closeBtn.onRollOut = closeBtn.onReleaseOutside = function(){
			this.gotoAndStop("normal");
		}				
		
		closeBtn.onRelease = function(){
			//refObj.removeMovieClip();
			refObj._visible = false;
		}
		
		obscurer.useHandCursor = false;
		obscurer.onRelease = function(){
			//do nothing
		}
		
		this.onKeyDown = function(){
			if(Key.getCode() == Key.END  && this._visible) {
				closeBtn.gotoAndStop("rollOver");
			}
		}
		
		this.onKeyUp = function(){
			if(Key.getCode() == Key.END  && this._visible){//close window
				closeBtn.gotoAndStop("normal");
				closeBtn.onRelease();
			}
		};
		Key.addListener(this);					
	}
	
	//Getter setter functions
	//title
	[Inspectable(name="title", type="String", defaultValue="Alert")]
	function set title(tStr:String):Void{
		__title = tStr;
		setTitle();
	}
	
	function get title():String{
		return __title;
	}
	
	//message
	[Inspectable(name="message", type="String")]
	function set message(mStr:String):Void{
		__message = mStr;
		setMessage();
	}
	
	function get message():String{
		return __message;
	}	
}