﻿import mx.core.UIComponent;
class com.trina.components.AudioTranscript extends UIComponent{
	
	private var transcriptText;
	private var transcriptAnim:MovieClip;
	private var pageText:String;
	private var invisBtn:Button;
	private var scrollerMC:MovieClip;
	
	function init(){
		scrollerMC._visible=false;
		transcriptText = this["transcriptText"];
		transcriptAnim = this["transcriptAnim"];
	}
	
	public function showText(txt:String):Void{
		invisBtn.useHandCursor = false;
		_global.currentClip.mediaLoader.stopAll();
		_parent.Navigator.setAllActive(false);
		_root.controlsClip.hideAll();
		
		transcriptAnim.closeBtn.onRollOver = function(){
			this.gotoAndStop("rollOver");
		}
		
		transcriptAnim.closeBtn.onRollOut = transcriptAnim.closeBtn.onReleaseOutside = function(){
			this.gotoAndStop("normal");
		}				
		
		transcriptAnim.closeBtn.onRelease = function () {
			this.gotoAndStop("normal");
			_root.contentClip.Navigator.transcriptActive = false;
			_root.transcript.hideText();	
			
		}
		
		playAnimForward();
		pageText = txt;
	}
	
	public function hideText():Void{
		transcriptText.text = "";
		pageText = "";
		_parent.Navigator.setAllActive(true);
		playAnimReverse();
		
	}
	
	private function playAnimReverse(){
		var cFrame:Number = transcriptAnim._currentframe;
		this.onEnterFrame = function(){
			transcriptAnim.gotoAndStop(cFrame);
			if(cFrame != 0){
				cFrame--;
			}else if(cFrame == 0){
				this._visible = false;
				_global.currentClip.mediaLoader.checkToStartWhenClose();
				_root.controlsClip.showAll();
				delete this.onEnterFrame;
			}
		}
	}
	
	private function playAnimForward(){
		var cFrame:Number = 0;
		var tFrames:Number = transcriptAnim._totalframes;
		this.onEnterFrame = function(){
			transcriptAnim.gotoAndStop(cFrame);
			cFrame++;
			if(cFrame == tFrames+1){
				transcriptText.htmlText = pageText;
				if(transcriptText.maxscroll >1 ) {
					scrollerMC._visible=true;
				} else {
					scrollerMC._visible=false;
				}
				delete this.onEnterFrame;
			}
		}
	}	

}