﻿import mx.core.UIComponent;
import com.trina.components.MediaLoader;

class com.trina.components.ContentPage extends UIComponent{
	static var symbolName:String = "ContentPage";
	static var symbolOwner:Object = com.trina.components.ContentPage;
	
	private var titleTxt;
	private var contentTxt;
	private var pageObj:Object = new Object();
	private var Navigator:MovieClip;
	private var stepLen:Number = 0;
	private var mediaLoader;
	private var maskMC:MovieClip;
	private var currentPage:Number;
	private var contentObj:Object;
	private var completedArr:Array;
	private var endOfScoAlertMC:MovieClip;
	
	function init(){
		titleTxt =  this["titleTxt"];
		contentTxt = this["contentTxt"];
		mediaLoader = this["mediaLoader"];
		pageObj = new Object();
		Navigator = this.createObject("Navigator", "Navigator", this.getNextHighestDepth());
		Navigator._x = 0;
		Navigator._y = this._height - Navigator._height + 8;		
		Navigator.compWidth = 980;
		mediaLoader.setMask(maskMC);
		reset();
	}
	
	public function setupKeyBoardInteractions(flag:Boolean) {
		Navigator.setupKeyBoardInteractions(flag);
	}
	public function initiateContent(pObj:Object, defaultPage:String){
		_root.aTxt += "initiateContent = " + pObj + " :: " + defaultPage + newline;
		trace("in initiate content == " + pObj + " : " + defaultPage);
		if (_global.currentPageNo != undefined) {
			defaultPage = _global.currentPageNo;
			if (defaultPage > 0) {
				for (var k = 0; k < defaultPage; k++) {
					updatePageVisited(k + 1);
				}
			}
		}
		contentObj = new Object();
		completedArr = new Array();
		pageObj = pObj;
		var refObj = this;
		stepLen = pageObj.step.length;
		
		//set page title
		titleTxt.htmlText = pageObj.name._value == undefined ? "" : pageObj.name._value;
		
		if(defaultPage != ""){
			showPage(defaultPage);
		}
		Navigator.setAllActive(false);
		//set the navigator
		Navigator.showSteps(pageObj, defaultPage);
		
		//event handler for the navigator
		Navigator.onStepRelease = function(stepID:String){
			refObj.showPage(stepID);
		}
		
	}
	
	//shows the page based on ID as parameter
	public function showPage(stepID:String):Void{
		mediaLoader.stopMedia();
		trace("in showPageeeee == " + stepID);
		Navigator.setAllInactiveWhenLoading();
		var i:Number = 0;
		for(i=0;i<stepLen;i++){
			if(pageObj.step[i].id == stepID){
				
				//set page content
				contentTxt.htmlText = pageObj.step[i].text._value;
				//load full page media if set to true
				currentPage = i + 1;
				if (pageObj.step[i].templateType == undefined) {
					// insert transition code here... amit
					// now loading the page from mediaLoader after transition
					var obj = pageObj.step[i];
					mediaLoader.startTransition(obj);
					//mediaLoader.loadClip(pageObj.step[i].graphic.src);
				} else {
					mediaLoader.startTransition1(pageObj.step[i].templateType + ".swf", pageObj.step[i]);
				}
				if (currentPage == 1) {
					Navigator.makeFirstPage(true);
				} else {
					Navigator.makeFirstPage(false);
				}
				if (isLastPage()) {
					Navigator.makeLastPage(true);
				} else {
					Navigator.makeLastPage(false);
				}
				break;
			}
		}

	}
	
	public function getCurrentPageNumber():Number {
		return currentPage;
	}
	
	public function getPageIndex() {
		var index:Number = 0;
		if (currentPage == 1) {
			index = 0;
		} else if (currentPage == stepLen) {
			index = 1;
		} else {
			index = 2;
		}
		return index;
	}
	
	public function isLastPage():Boolean {
		var bool:Boolean = false;
		if (currentPage == stepLen) {
			bool = true;
		}
		return bool;
	}
	
	public function updatePageVisited(id) {
		completedArr["page" + id] = true;
		checkAllCompleted();
	}
	
	public function checkAllCompleted() {
		var bool = true;
		for (var k = 1; k <= stepLen; k++) {
			if (completedArr["page" + k]) {
				
			} else {
				bool = false;
				break;
			}
		}
		if (bool) {
			_global.isScoCompleted = true;
			_global.completedArray.push(_global.selectedSco);
			_root.amit += "pushing into completed array == " + _global.completedArray + newline;
		}
	}
	
	public function stopMedia(){
		mediaLoader.unloadClip();
	}
	
	public function jumpForward(){
		if (currentPage == stepLen) {
			showNextScoMessage();
		} else {
			Navigator.setAllActive(true);
			Navigator.controlHolder.right.onRelease();
		}
	}
	
	public function showNextScoMessage() {
		mediaLoader.removePractice();
		Navigator.setAllActive(false);
		_root.controlsClip.hideAll();
		endOfScoAlertMC = this.attachMovie("EndOfScoAlert", "endOfScoAlert", this.getNextHighestDepth());
	
	}
	
	public function reset():Void{
		Navigator.reset();
	}
	
}