﻿// com.trina.components.EndAlert

class com.trina.components.EndAlert extends com.trina.utils.AniMovieClip {
	private var alertObj:Object;
	private var titleTxt:TextField;
	private var messageTxt:TextField;
	private var stepUpBtn:MovieClip;
	private var closeBtn:MovieClip;
	
	function EndAlert() {
		this.onLoad = function () {
			init();
		}
	}
	
	
	public function init() {
		// title is not there right now.. if you want then just place the text box and 
		// entry in xml it will work fine.
		//titleTxt.text = _global.courseObj.endOfSco.titleMessage._value;
		messageTxt.text = _global.courseObj.endOfSco.alertMessage._value;
		
		setInteractions();
	}
	
	public function closeWindow() {
		_parent.Navigator.setAllActive(true);
		_root.controlsClip.showAll();
		_parent.mediaLoader.reInitialize();
		this.removeMovieClip();
	}
	
	private function setInteractions() {
		
		closeBtn.onRollOver = function(){
			this.gotoAndStop("rollOver");
		}
		
		closeBtn.onRollOut = closeBtn.onReleaseOutside = function(){
			this.gotoAndStop("normal");
		}				
		
		closeBtn.onRelease = function(){
			_parent.closeWindow();
		}
		
		stepUpBtn.onRollOver = function(){
			this.gotoAndStop("rollOver");
		}
		
		stepUpBtn.onRollOut = stepUpBtn.onReleaseOutside = function(){
			this.gotoAndStop("normal");
		}		
		//takes one level up from current location
		stepUpBtn.onRelease = function(){
			_root.stopSound();
			_parent.closeWindow();
			if(_global.parentCallBackFn != null){
				if(_global.currentClip._name == "contentClip"){
					_global.currentClip.stopMedia();
				}
				_global.currentClip._visible = false;
				_global.parentCallBackFn.call();
			}
			
		}
		
		
		setupKeyBoardInteractions(true);
	}
	
	public function setupKeyBoardInteractions(flag:Boolean) {
		if (flag) {
			this.onKeyDown = function(){
				if(Key.getCode() == Key.PGUP && this._visible && stepUpBtn.enabled){//Step up button
					stepUpBtn.gotoAndStop("rollOver");
				}
				
				if(Key.getCode() == Key.BACKSPACE && this._visible && stepUpBtn.enabled){//Step up button
					stepUpBtn.gotoAndStop("rollOver");
				}
				
				if(Key.getCode() == Key.END && this._visible) {
					closeBtn.gotoAndStop("rollOver");
				}
			}
			
			this.onKeyUp = function(){
				if(Key.getCode() == Key.PGUP && this._visible && stepUpBtn.enabled){//Step up button
					stepUpBtn.gotoAndStop("normal");
					stepUpBtn.onRelease();								
				}
				
				if(Key.getCode() == Key.BACKSPACE && this._visible && stepUpBtn.enabled){//Step up button
					stepUpBtn.gotoAndStop("normal");
					stepUpBtn.onRelease();								
				}
				
				if(Key.getCode() == Key.END && this._visible){//close window
					closeBtn.gotoAndStop("normal");
					closeBtn.onRelease();
				}
				
			};
			Key.addListener(this);	
		} else {
			Key.removeListener(this);
		}
	}
}