﻿//
import mx.core.UIComponent;
class com.trina.components.GlobalControls extends UIComponent{
	static var symbolName:String = "GlobalControls";
	static var symbolOwner:Object = com.trina.components.GlobalControls;
	
	private var stepUpBtn:MovieClip;
	private var homeBtn:MovieClip;
	private var helpBtn:MovieClip;
	private var exitBtn:MovieClip;
	private var state:Number;

	function init(){
		stepUpBtn = this["stepUpBtn"];
		homeBtn = this["homeBtn"];
		helpBtn = this["helpBtn"];
		exitBtn = this["exitBtn"];
		
		setInteractions();
	}
	
	private function setInteractions(){
		var refObj = this;
		
		stepUpBtn.onRollOver = function(){
			this.gotoAndStop("rollOver");
		}
		
		stepUpBtn.onRollOut = stepUpBtn.onReleaseOutside = function(){
			this.gotoAndStop("normal");
		}		
		
		//takes one level up from current location
		stepUpBtn.onRelease = function(){
			_root.stopSound();
			if(_global.parentCallBackFn != null){
				if(_global.currentClip._name == "contentClip"){
					_global.currentClip.stopMedia();
				}
				//_global.currentClip._visible = false;
				_global.parentCallBackFn.call();
			}
		}
		
		homeBtn.onRollOver = function(){
			this.gotoAndStop("rollOver");
		}
		
		homeBtn.onRollOut = homeBtn.onReleaseOutside = function(){
			this.gotoAndStop("normal");
		}		
		
		//takes to the course home page
		homeBtn.onRelease = function(){
			_root.stopSound();
			if(_global.currentClip._name == "contentClip"){
				_global.currentClip.stopMedia();
			}			
			_global.currentClip._visible = false;
			//_root.showHomePage();
			_root.showMainMenu();
		}
		
		helpBtn.onRollOver = function(){
			this.gotoAndStop("rollOver");
		}
		
		helpBtn.onRollOut = helpBtn.onReleaseOutside = function(){
			this.gotoAndStop("normal");
		}				
		
		helpBtn.onRelease = function(){
			_root.stopSound();
			_root.showContextHelp();
		}
		
		exitBtn.onRollOver = function(){
			this.gotoAndStop("rollOver");
		}
		
		exitBtn.onRollOut = exitBtn.onReleaseOutside = function(){
			this.gotoAndStop("normal");
		}				
		
		//exits the application
		exitBtn.onRelease = function(){
			getURL("javaScript:top.close()");
			//fscommand("closeWindow");
		}
		
		this.onKeyDown = function(){
			if(Key.getCode() == Key.END  && this._visible && !_root.alert._visible && exitBtn.enabled){//close window
				exitBtn.gotoAndStop("rollOver");
			}
			if(Key.getCode() == Key.INSERT  && this._visible && helpBtn.enabled){//Help Button
				helpBtn.gotoAndStop("rollOver");
			}
			if(Key.getCode() == Key.HOME  && this._visible && homeBtn.enabled){//Home button
				homeBtn.gotoAndStop("rollOver");
			}
			if(Key.getCode() == Key.PGUP  && this._visible && stepUpBtn.enabled){//Step up button
				stepUpBtn.gotoAndStop("rollOver");
			}
			
			if(Key.getCode() == Key.BACKSPACE && this._visible && stepUpBtn.enabled){//Step up button
				if (eval(Selection.getFocus())._name != "selectedID") {
					stepUpBtn.gotoAndStop("rollOver");
				}
			}
			
		};
		
		
		this.onKeyUp = function(){
			if(Key.getCode() == Key.END  && this._visible && !_root.alert._visible && exitBtn.enabled){//close window
				exitBtn.gotoAndStop("normal");
				exitBtn.onRelease();
			}
			if(Key.getCode() == Key.INSERT  && this._visible && helpBtn.enabled){//Help Button
				helpBtn.gotoAndStop("normal");
				helpBtn.onRelease();
			}
			if(Key.getCode() == Key.HOME  && this._visible && homeBtn.enabled){//Home button
				homeBtn.gotoAndStop("normal");
				homeBtn.onRelease();
			}
			if(Key.getCode() == Key.PGUP  && this._visible && stepUpBtn.enabled){//Step up button
				stepUpBtn.gotoAndStop("normal");
				stepUpBtn.onRelease();								
			}
			
			if(Key.getCode() == Key.BACKSPACE && this._visible && stepUpBtn.enabled){//Step up button
				if (eval(Selection.getFocus())._name != "selectedID") {
					stepUpBtn.gotoAndStop("normal");
					stepUpBtn.onRelease();								
				}
			}
			
		};
		Key.addListener(this);			
	}
	
	public function showExitOnly(){
		state = 1;
		stepUpBtn._alpha = 40;
		homeBtn._alpha = 40;
		helpBtn._alpha = 40;
		stepUpBtn.enabled = false;
		homeBtn.enabled = false;
		helpBtn.enabled = false;
	}
	
	public function showHelpOnly(){
		state = 2;
		stepUpBtn._alpha = 40;
		homeBtn._alpha = 40;
		helpBtn._alpha = 100;
		exitBtn._alpha = 40;
		stepUpBtn.enabled = false;
		homeBtn.enabled = false;
		helpBtn.enabled = true;
		exitBtn.enabled = false;
		stepUpBtn.gotoAndStop("normal");
		homeBtn.gotoAndStop("normal");
		exitBtn.gotoAndStop("normal");
	}
	
	public function showHelpAndExit(){
		state = 3;
		stepUpBtn._alpha = 40;
		homeBtn._alpha = 40;
		helpBtn._alpha = 100;
		exitBtn._alpha = 100;
		stepUpBtn.enabled = false;
		homeBtn.enabled = false;
		helpBtn.enabled = true;
		exitBtn.enabled = true;
		stepUpBtn.gotoAndStop("normal");
		homeBtn.gotoAndStop("normal");
	}	
	
	public function hideAll(){
		stepUpBtn._alpha = 40;
		homeBtn._alpha = 40;
		helpBtn._alpha = 40;
		exitBtn._alpha = 40;
		stepUpBtn.enabled = false;
		homeBtn.enabled = false;
		helpBtn.enabled = false;
		exitBtn.enabled = false;
		stepUpBtn.gotoAndStop("normal");
		homeBtn.gotoAndStop("normal");
		exitBtn.gotoAndStop("normal");		
		helpBtn.gotoAndStop("normal");		
	}	
	
	public function showAll(){
		state = 4;
		stepUpBtn._alpha = 100;
		homeBtn._alpha = 100;
		helpBtn._alpha = 100;
		exitBtn._alpha = 100;
		stepUpBtn.enabled = true;
		homeBtn.enabled = true;
		helpBtn.enabled = true;
		exitBtn.enabled = true;
	}
	
	public function showAllCondition() {
		if (state == 1) {
			showExitOnly();
		} else if (state == 2) {
			showHelpOnly();
		} else if (state == 3) {
			showHelpAndExit();
		} else {
			showAll();
		}
	}
}