﻿//
import mx.core.UIComponent;
class com.trina.components.HomePage extends UIComponent{
	static var symbolName:String = "HomePage";
	static var symbolOwner:Object = com.trina.components.HomePage;
	
	private var userNameText;
	private var leftBtn:MovieClip;
	private var rightBtn:MovieClip;
	
	private var bgLoader:MovieClip;
	private var __courseBtnAudio:String;
	private var __assmtBtnAudio:String;
	

	function init(){
		userName = _global.currentUser;
		userNameText = this["userNameText"];
		bgLoader = this["bgLoader"];
		rightBtn = this["rightBtn"];
		leftBtn = this["leftBtn"];
		
		setInteractions();
	}
	
	//function sets the interactions for the components withing the clip
	private function setInteractions():Void{
		var refObj = this;
		
			
		
		
		
		rightBtn.onRollOver = function(){
			if(refObj.__courseBtnAudio != undefined && _global.pageSoundsCompleted){
				_root.playSound(refObj.__courseBtnAudio);
			}
			this.gotoAndStop("rollOver");
		}
		
		rightBtn.onRollOut = function(){
			if(_global.pageSoundsCompleted){
				_root.stopSound();
			}
			this.gotoAndStop("normal");
		}
		
		rightBtn.onRelease = function(){
			refObj.onOptionSelect("aggregates");
		}
		
		leftBtn.onRollOver = function(){
			if(refObj.__assmtBtnAudio != undefined && _global.pageSoundsCompleted){
				_root.playSound(refObj.__assmtBtnAudio);
			}			
			this.gotoAndStop("rollOver");
		}
		
		leftBtn.onRollOut = function(){
			if(_global.pageSoundsCompleted){
				_root.stopSound();
			}
			this.gotoAndStop("normal");
		}
		
		leftBtn.onRelease = function(){
			refObj.onOptionSelect("assessments");
		}		
		setupKeyBoardInteractions(true);
		
	}
	
	public function setupKeyBoardInteractions(flag:Boolean) {
		var LEFTARROW = 37;
		var TOPARROW = 38;
		var RIGHTARROW = 39;
		var BOTTOMARROW = 40;
		if (flag) {
			this.onKeyDown = function(){
				if(Key.getCode() == LEFTARROW && leftBtn.enabled){
					leftBtn.gotoAndStop("rollOver");
				}else if(Key.getCode() == RIGHTARROW){
					rightBtn.gotoAndStop("rollOver");
				}			
			}
			
			this.onKeyUp = function(){
				if(Key.getCode() == LEFTARROW && this._visible && leftBtn.enabled){
					leftBtn.onRelease();
					leftBtn.gotoAndStop("normal");
				}else if(Key.getCode() == RIGHTARROW && this._visible){
					rightBtn.onRelease();
					rightBtn.gotoAndStop("normal");
				}			
			}
			
			Key.addListener(this);
			leftBtn.enabled = rightBtn.enabled = true;
			leftBtn._alpha = rightBtn._alpha = 100;
		} else {
			Key.removeListener(this);
			leftBtn.enabled = rightBtn.enabled = false;
			leftBtn._alpha = rightBtn._alpha = 50;
		}
		leftBtn.enabled = false;
		leftBtn._alpha = 50;
	}
	
	
	//Public functions
	public function onOptionSelect(optStr:String):Void{
		if(optStr == "aggregates"){
			_global.appPath.showMainMenu();
		}else if(optStr == "assessments"){
			_global.appPath.showAssessment();
		}
	}

	
	public function getString(num:Number) {
		return (num > 9 ? ("" + num) : ("0" + num));
	}
	
	//loads the image from the specified path
	public function loadBG(imPath){
		bgLoader.loadMovie(imPath);
	}	
	
	//getter setter functions
	[Inspectable(name = "userName", type="String")]
	function set userName(uVal:String):Void{
		userNameText.text = uVal;
	}
	
	function get userName():String{
		return userNameText.text;
	}
	
	[Inspectable(name = "courseBtnAudio", type="String")]
	function set courseBtnAudio(aVal:String):Void{
		__courseBtnAudio = aVal;
	}
	
	[Inspectable(name = "assmtBtnAudio", type="String")]
	function set assmtBtnAudio(aVal:String):Void{
		__assmtBtnAudio = aVal;
	}	
	//end of getter setter functions
	
}