﻿//
import mx.core.UIComponent;
class com.trina.components.MainMenu extends UIComponent{
	static var symbolName:String = "MainMenu";
	static var symbolOwner:Object = com.trina.components.MainMenu;

	private var xPos:Number = 18;
	private var defaultYPos:Number = 100;
	private var yPos:Number = defaultYPos;
	private var xPos2:Number = 540;
	private var vPadding:Number = 5;
	private var itemContainer:Array;
	private var userNameTxt;
	private var pageText;
	private var lmsBtn:MovieClip;
	private var lvTxt:TextField;
	
	private var selectedID;
	private var enterBtn:MovieClip;
	private var bgLoader:MovieClip;
	
	function MainMenu(){
		selectedID = this["selectedID"];
		enterBtn = this["enterBtn"];
		userNameTxt = this["userNameTxt"];
		pageText = this["pageText"];
		bgLoader = this["bgLoader"];
		
		this.onLoad = function(){
			selectedID.tabEnabled = true;
			selectedID.tabIndex = 1;
			enterBtn.tabEnabled = true;
			enterBtn.tabIndex = 2;
			Selection.setFocus("selectedID");
			itemContainer = new Array();
			selectedID.restrict = "0-9";
			showTaskItems(_global.courseObj);
			userNameTxt.text = _root.userName ==  undefined ? "" : _root.userName;
			lmsBtn._visible = false;
			lvTxt._visible = false;
		}
	}

	
	//Public
	public function showTaskItems(cObj):Void{
		xPos = 18;
		yPos = defaultYPos;
		selectedID.text = "";
		
		if (_global.lastVisitedPage == "" || _global.lastVisitedPage == undefined) {
			lmsBtn._visible = false;
			lvTxt._visible = false;
		}
		
		
		lmsBtn.onRollOver = function () {
			this.gotoAndStop("rollOver");
		}
		lmsBtn.onRollOut = function(){
			this.gotoAndStop("normal");
		}
		lmsBtn.onRelease = function () {
			_parent.onLMSSelect();
		}
		
		
		
		//clear previous taskItems
		clearPreviousTaskItems();
		
		var aggregateLen:Number = 0;
		var i:Number = 0;
		var mainMenuItem:MovieClip;
		
		//Show Page text
		pageText.text = cObj.mainMenu.text._value;		
		
		aggregateLen = cObj.aggregate.length;
		
		for(i=0;i<aggregateLen;i++){
			mainMenuItem = this.createObject("mainMenuItem", "mainMenuItem" + this.getNextHighestDepth(), this.getNextHighestDepth(), {_x:xPos, _y:yPos});
			var iName = (cObj.aggregate[i].name._value == undefined)? "" : cObj.aggregate[i].name._value;
			var iText = (cObj.aggregate[i].text._value == undefined)? "" : cObj.aggregate[i].text._value;
			
			mainMenuItem.itemTxt.htmlText = "<b>" + iName + "</b>";// + "<br>" + iText;
			mainMenuItem.itemID.text = i+1;
			mainMenuItem.itemID.autoSize = "center";
			mainMenuItem.id = cObj.aggregate[i].id;
			mainMenuItem.state = cObj.aggregate[i].state == "false" ? false : true;
			mainMenuItem.soundPath = cObj.aggregate[i].buttonAudio._value;
			mainMenuItem.bgLoader.loadMovie(cObj.aggregate[i].bgImage);
			
			itemContainer.push(mainMenuItem);
			
			//set item level interactions
			setItemInteractions(mainMenuItem);
			
			yPos += mainMenuItem._height + vPadding;
			
			if(i ==  7){
				xPos = xPos2;
				yPos = defaultYPos;
			}
		}
		playPageAudio(_global.courseObj.mainMenu.pageAudio._value);
		resetIDField();
	
		Selection.setFocus(selectedID);
		//set global interactions for this page
		setInteractions();
		
	}
	
	//Clears previously shown tasks if any
	private function clearPreviousTaskItems():Void{
		var i:Number = 0;
		
		for(i=0;i<itemContainer.length;i++){
			itemContainer[i].removeMovieClip();
		}
	}
	
	//set the interactions for the enter button
	private function setInteractions():Void{
		var refObj = this;
		
		enterBtn.onRollOver = function(){
			this.gotoAndStop("rollOver");
		}
		
		enterBtn.onRollOut = enterBtn.onReleaseOutside = function(){
			this.gotoAndStop("normal");
		}		
		
		enterBtn.onRelease = function(){
			if(!isNaN(Number(refObj.selectedID.text)) && refObj.itemContainer[Number(refObj.selectedID.text)-1].id  != undefined){
				if (refObj.itemContainer[Number(refObj.selectedID.text)-1].state) {
					refObj.onItemSelected(refObj.itemContainer[Number(refObj.selectedID.text)-1].id);
				} else {
					refObj.setCursorSelection();
				}
			} else {
				refObj.setCursorSelection();
			}
		}	
		setupKeyBoardInteractions(true);
	}
	
	public function setCursorSelection() {
		Selection.setFocus("_level0.mainMenuClip.selectedID");
		Selection.setSelection(0, 0);
	}
	
	public function setupKeyBoardInteractions(flag:Boolean) {
		if (flag) {
			this.onKeyDown = function(){
				if(Key.getCode() == Key.ENTER  && this._visible)
					enterBtn.gotoAndStop("rollOver");
			}		
			
			this.onKeyUp = function(){
				if(Key.getCode() == Key.ENTER  && this._visible && !isNaN(Number(selectedID.text))){
					enterBtn.gotoAndStop("normal");
					if(itemContainer[Number(selectedID.text)-1].id  != undefined){
						if (itemContainer[Number(selectedID.text)-1].state) {
							onItemSelected(itemContainer[Number(selectedID.text)-1].id);
						}
					}
				}
			};
			Key.addListener(this);
			var len = itemContainer.length;
			for (var k = 0; k < len; k++) {
				setItemInteractions(itemContainer[k]);
			}
			enterBtn.enabled = true;
		} else {
			Key.removeListener(this);
			var len = itemContainer.length;
			for (var k = 0; k < len; k++) {
				itemContainer[k].btn.enabled = false;
				itemContainer[k]._alpha = 50;
			}
			enterBtn.enabled = false;
		}
		
	}
	
	
	private function setItemInteractions(item:MovieClip):Void{
		var refObj = this;
		
		item.btn.onRollOver = function(){
			if(this._parent.soundPath != undefined && _global.pageSoundsCompleted){
				_root.playSound(this._parent.soundPath);
			}
		}
		
		item.btn.onRollOut = function(){
			if(_global.pageSoundsCompleted){
				_root.stopSound();
			}
		}		
		
		item.btn.onRelease = function(){
			refObj.onItemSelected(this._parent.id);
		}
		if (item.state) {
			item.btn.enabled = true;
			item._alpha = 100;
		} else {
			item.btn.enabled = false;
			item._alpha = 50;
		}
	}
	
	//public function
	public function onItemSelected(itemID:String){
		_global.appPath.showVariantList(itemID);
	}
	
	public function onLMSSelect() {
		var arr = _global.lastVisitedPage.split("_");
		var itemID = arr[0] + "_" + arr[1] + "_" + arr[2] + "_" + arr[3];
		var pageNo = Number(arr[4]);
		_global.navObject.aggregate = getString(Number(arr[0].substring(1, arr[0].length)));
		_global.navObject.variant = getString(Number(arr[1].substring(1, arr[1].length)));
		_global.navObject.task = getString(arr[2].substring(1, arr[2].length));
		_global.navObject.page = getString(arr[3].substring(2, arr[3].length));
		_global.variantID = arr[0];
		_global.taskID = arr[0] + "_" + arr[1];
		_global.subtaskID = arr[0] + "_" + arr[1] + "_" + arr[2];
		_global.selectedSco = itemID;
		_root.aTxt += "showPageContent == " + itemID + " :: " + pageNo;
		_root.showPageContent(itemID, pageNo);
	}
	
	public function getString(num:Number) {
		return (num > 9 ? ("" + num) : ("0" + num));
	}
	
	//loads the image from the specified path
	public function loadBG(imPath){
		bgLoader.loadMovie(imPath);
	}
	
	//page audio
	public function playPageAudio(path):Void{
		//Page Audio
		//stop old sounds
		_root.stopSound();
		if(path != undefined){
			_root.playPageSound(path);
		}										
	}
	
	public function resetIDField(){
		selectedID.text = "";
	}
	
	//getter setter functions
	[Inspectable(name = "userName", type="String")]
	function set userName(uVal:String):Void{
		userNameTxt.text = uVal;
	}
	
	function get userName():String{
		return userNameTxt.text;
	}
	//end of getter setter functions	
}