﻿class com.trina.components.MediaLoader extends com.trina.utils.AniMovieClip {
	private var container:MovieClip;	
	private var pageObj:Object;
	private var mId:Number;
	private var mySound:Sound;
	private var file:String;
	private var practiceMC:MovieClip;
	private var questionAudio:Sound;
	private var fb1Audio:Sound;
	private var fb2Audio:Sound;
	private var currentSoundPos:Number;
	private var isMediaEnd:Boolean;
	private var isPlayStopped:Boolean;
	private var isPracticeOpen:Boolean;



	function MediaLoader() {
		_root.path1 = this;
	}
	
	public function unloadClip() {
		container.removeMovieClip();
		removePractice();
		currentSoundPos = mySound.position / 1000;
		mySound.stop();
		
	}
	
	public function getPath():String {
		var pagePath:String = "content/aggregate" + _global.navObject.aggregate + "/variant" + _global.navObject.variant + "/task" + _global.navObject.task + "/media/sco" + _global.navObject.page +"/";
		return pagePath;
	}
	
	public function cleanUp() {
		container.removeMovieClip();
		practiceMC.removeMovieClip();
		removeMovieClip(practiceMC);
		removeMovieClip(container);
		
	}
	
	public function loadClip(fl:String, flag:Boolean) {
		
		_global.contentCompleted = false;
		cleanUp();
		if (file == undefined) {
			var filePath = getPath();
		} else {
			var filePath = "";
		}
		
		container = this.createEmptyMovieClip("container", this.getNextHighestDepth());
		
		var mcListener:Object = new Object();
		mcListener.onLoadStart = function(target_mc:MovieClip) {
		    // show loader here
		};
		mcListener.onLoadComplete = function(target_mc:MovieClip) {
		    //target_mc.completeTimer = getTimer();
		};
		mcListener.onLoadInit = function(target_mc:MovieClip) {
			target_mc.stop();
			if (target_mc._parent.file == undefined) {
				_global.contentLoaded = true;
			}		    
		};
		var mcLoader:MovieClipLoader = new MovieClipLoader();
		mcLoader.addListener(mcListener);
		mcLoader.loadClip(filePath + fl, container);
		
		if (_global.isPPSEnabled) {
			var pageURL = getPath() + pageObj.graphic.src;
			getURL("javascript:setPageID('" + pageURL + "')");
			delete pageURL;
		}
		
		var str:String = "a" + Number(_global.navObject.aggregate) + "_v" + Number(_global.navObject.variant) + "_t" + Number(_global.navObject.task) + "_st" + Number(_global.navObject.page) + "_" + _parent.getCurrentPageNumber();
		_root.setLastVisited(str);
		
	}
	
	public function loadAudio(file) {
		currentSoundPos = 0;
		mySound = new Sound();
		_global.soundCompleted = false;
		mySound.onLoad = function (success:Boolean) {
			if (success) {
				mySound.stop();
				_global.soundLoaded = true;
			} else {
				_global.soundLoaded = true;
				_global.soundCompleted = true;
			}
		}
		if (file == undefined) { 
			// no need of sound complete event as the media file will call for jump 
		} else {
			
			mySound.onSoundComplete = function () {
				_global.soundCompleted = true;
				_root.path1.currentSoundPos = 0;
				_root.path1.jumpForward(true);
			}
		}
		var filePath = getPath() + "audio/";
		mySound.loadSound(filePath + file, false);
	}
	
	
	public function checkToStart() {
		if (isMediaEnd) {
			return;
		} else {
			startAll();
		}
	}
	
	public function checkToStartWhenClose() {
		if (isPracticeOpen) {
			drawPractice();
			return;
		}
		trace("checking here imp ***** == " + isPlayStopped)
		if (isPlayStopped) {
			return;
		} else {
			checkToStart();
		}
	}
	
	public function makeMediaState(flag) {
		trace("chaning play state == " + flag)
		isPlayStopped = flag;
	}
	
	public function stopAll() {
		
		container.stop();
		container.container.stop();
		container.contentMC.container.stop();
		currentSoundPos = mySound.position / 1000;
		mySound.stop();
		_parent.Navigator.resetControls(false);
	}
	
	public function startAll() {
		container.play();
		container.container.play();
		container.contentMC.container.play();
		mySound.start(currentSoundPos);
		mySound.setVolume(100);
		_parent.Navigator.resetControls(true);
	}
	
	public function startMedia() {
		isMediaEnd = false;
		
		_parent.Navigator.resetControls(true);
		_parent.updatePageVisited(pageObj.id);
		container.play();
		container.container.play();
		container.contentMC.container.play();
		mySound.start(currentSoundPos);
		mySound.setVolume(100);
	}
	
	public function stopMedia() {
		currentSoundPos = mySound.position / 1000;
		mySound.stop();
	}
	
	public function startTransition(obj1:Object) {
		file = undefined;
		pageObj = obj1;
		var obj:Object = new Object();
		obj.alphaBegin = 100;
		obj.alphaEnd = 0;
		obj.duration = .5;
		obj.isCallBack = true;
		this.doAlphaTransition(obj);
	}
	
	public function startTransition1(fl:String, obj1:Object) {
		file = fl;
		pageObj = obj1;
		var obj:Object = new Object();
		obj.alphaBegin = 100;
		obj.alphaEnd = 0;
		obj.duration = .5;
		obj.isCallBack = true;
		this.doAlphaTransition(obj);
	}
	
	public function getPageObject() {
		loadAudio(pageObj.audio.src);
		startChecking();
		return pageObj;	
	}
	
	public function endTransition() {
		var obj:Object = new Object();
		obj.alphaBegin = 0;
		obj.alphaEnd = 100;
		obj.duration = .5;
		obj.isCallBack = false;
		this.doAlphaTransition(obj);
		_parent.Navigator.setAllActive(true);
	}
	
	public function handleAnimationCallBack() {
		_global.contentLoaded = false;
		_global.soundLoaded = false;
		if (file == undefined) {
			loadClip(pageObj.graphic.src);
			if (pageObj.audio.src == undefined || pageObj.audio.src.length <= 0) {
				_global.soundLoaded = true;
				mySound = new Sound();
			} else {
				loadAudio(pageObj.audio.src);
			}
			startChecking();
		} else {
			loadClip(file);
		}
		isPracticeOpen = false;
		var obj:Object = new Object();
		obj.container = container;
		obj.mySound = mySound;
		if (file == undefined) {
			obj.inContainer = undefined;
		} else {
			obj.inContainer = container.contentMC.container;
		}

		var loaderMC = this._parent.attachMovie("loadingMC", "loaderMc", this.getNextHighestDepth(), {loadObj:obj});
		loaderMC._x = 455;
		loaderMC._y = 290;
		
		// show loader here
	}
	
	public function startChecking() {
		clearInterval(mId);
		mId = setInterval(this, "checkAllLoaded", 50);
	}
	public function checkAllLoaded() {
		if (_global.contentLoaded && _global.soundLoaded) {
			clearInterval(mId);
			delete mId;
			endTransition();
			isPlayStopped = false;
			startMedia();		
		}
	}
	
	public function insideContentLoaded() {
		_global.contentLoaded = true;
	}
	
	public function jumpForwardNow() {
		_parent.jumpForward();
	}
	
	public function jumpForward (flag:Boolean) {
		if (flag == undefined) {
			_global.contentCompleted = true;
		}
		if (_global.soundCompleted && _global.contentCompleted) {
			isMediaEnd = true;
			if (pageObj.Practice == undefined) {
				_parent.jumpForward();
			} else {
				showPractice()
			}
		}
	}
	public function reInitialize() {
		_global.soundCompleted = false;
		_global.contentCompleted = false;
		_parent.Navigator.resetControls(false);
		
	}
	public function showPractice() {
		//currentSoundPos = mySound.position / 1000;
		
		mySound.stop();
		practiceMC.removeMovieClip();		
		practiceMC = this.attachMovie("PracticeComponent", "pc", this.getNextHighestDepth(), {pracObj:pageObj.Practice});
		practiceMC._x = 25;
		practiceMC._y = -600;
		drawPractice();
		isPracticeOpen = true;
		
	}
	
	public function drawPractice() {
		questionAudio = new Sound();
		fb1Audio = new Sound();
		fb2Audio = new Sound();
		
		//var bool = _parent.isLastPage();
		//if (bool) {
		_parent.Navigator.setAllActive(false);
		//}
		
		questionAudio.onLoad = function (success) {
			this.startChecking();
			_root.path1.questionAudio.start();
			_root.path1.loadOtherSounds();
		}
		questionAudio.onSoundComplete = function () {
			// do what now?
		}
		fb1Audio.onLoad = function () {
			fb1Audio.stop();
		}
		fb2Audio.onLoad = function () {
			fb2Audio.stop();
		}
		
		fb1Audio.onSoundComplete = function () {
			_root.path1.jumpForwardNow();
		}
		fb2Audio.onSoundComplete = function () {
			_root.path1.jumpForwardNow();
		}
		
		var filePath = getPath() + "audio/";
		questionAudio.loadSound(filePath + pageObj.Practice.Question.audio, false);
	
	}
	
	public function removePractice() {
		isPracticeOpen = false;
		practiceMC.removeMovieClip();
		_parent.Navigator.setAllActive(true);
	}
	
	public function playSoundForFeedback(num:Number) {
		questionAudio.stop();
		if (num == 1) {
			fb1Audio.start();
		} else {
			fb2Audio.start();
		}
	}
	
	public function loadOtherSounds() {
		var filePath = getPath() + "audio/";
		fb1Audio.loadSound(filePath + pageObj.Practice.CorrectFeedback.audio, false);
		fb2Audio.loadSound(filePath + pageObj.Practice.IncorrectFeedback.audio, false);
	}
	
	public function rePosition(ht:Number) {
		practiceMC._y = (715 - 170 - ht) / 2;
	}

}