﻿//
import mx.core.UIComponent;
class com.trina.components.Navigator extends UIComponent{
	static var symbolName:String = "Navigator";
	static var symbolOwner:Object = com.trina.components.Navigator;

	private var controlHolder:MovieClip;
	private var stepContainer:Array;
	private var taskName;
	private var pageTitle:String;
	private var currentStepPos:Number = 0;
	private var __compWidth:Number =  600;
	private var pageStopped:Boolean = false;
	private var taskNum;
	private var pageIndicator;
	private var transcriptActive:Boolean = false;
	private var transcriptAnim:MovieClip;
	private var isFirstPage:Boolean = false;
	private var isLastPage:Boolean = false;
	private var navObj:Object;

	
	//component initialization
	function init(){
		taskName = this["taskName"];
		taskNum = this["taskNum"];
		stepContainer = new Array();
		controlHolder = this.createObject("controlHolder", "controlHolder", this.getNextHighestDepth());
	}
	
	//getter setter functions
	[Inspectable(name="compWidth", type="Number", defaultValue="300")]
	function set compWidth(wVal:Number):Void{
		__compWidth = wVal;
		repositionControls();
	}
	
	function get compWidth():Number{
		return __compWidth;
	}
	
	//end of getter setter functions
	
	// This will paint the steps
	public function showSteps(pageObj:Object, currentPage:String):Void{
		navObj = new Object();
		var i:Number = 0;
		var stepLen:Number = pageObj.step.length;
		var step:MovieClip;
		var xPos:Number = 0;
		var yPos:Number = 72;
		var stepDistIncrement:Number = 14;
		pageStopped = false;
		
		//remove old stuff
		if(stepContainer.length > 0){
			for(i=0;i<stepContainer.length;i++){
				stepContainer[i].removeMovieClip();
			}
		}
		
		stepContainer = new Array();
		
		this["pageIndicator"].removeMovieClip();
		
		for(i=0;i<stepLen;i++){
			if((i+1)%2 == 0){
				step = this.createObject("step_brown", "step" + this.getNextHighestDepth(), this.getNextHighestDepth());
			}else{
				step = this.createObject("step_yellow", "step" + this.getNextHighestDepth(), this.getNextHighestDepth());
			}
			step._x = xPos;
			step._y = yPos;

			if(currentPage == pageObj.step[i].id){
				pageTitle = pageObj.step[i].title._value;
				currentStepPos = i;
				showText();
			}else{
				step._alpha = 50;
			}
			step.stepObj = pageObj.step[i];
			step.arrPos = i;

			//set interactions
			stepInteractions(step);
			stepContainer.push(step);
			
			xPos += stepDistIncrement;
		}
		
		pageIndicator = this.createObject("Indicator", "pageIndicator", this.getNextHighestDepth());
		pageIndicator._x = stepContainer[currentStepPos]._x + stepContainer[currentStepPos]._width/2 - pageIndicator._width/2;
		pageIndicator._y = stepContainer[currentStepPos]._y + stepContainer[currentStepPos]._height/2 - pageIndicator._height/2;				
		repositionControls();
		setControlInteractions();
		setAllActive(true);
	}

	
	//sets interactions for the step
	private function stepInteractions(step:MovieClip):Void{
		var refObj:MovieClip = this;
		
		step.onRelease = function(){
			refObj.pageTitle = this.stepObj.title._value;
			refObj.currentStepPos = this.arrPos;
			refObj.showText();
			this._alpha = 100;
			refObj.pageIndicator._x = this._x + this._width/2 - refObj.pageIndicator._width/2;
			refObj.pageIndicator._y = this._y + this._height/2 - refObj.pageIndicator._height/2;				
			
			refObj.onStepRelease(this.stepObj.id);
		}
		
	}
	
	//sets the control interactions
	public function setupKeyBoardInteractions(flag:Boolean) {
		var LEFTARROW = 37;
		var TOPARROW = 38;
		var RIGHTARROW = 39;
		var BOTTOMARROW = 40;
		var END = 35;
		if (flag) {
			this.onKeyDown = function(){
				if(Key.getCode() == LEFTARROW && !transcriptActive && controlHolder.left.enabled){
					controlHolder.left.gotoAndStop("rollOver");
				}else if(Key.getCode() == RIGHTARROW && !transcriptActive && controlHolder.right.enabled){
					controlHolder.right.gotoAndStop("rollOver");
				}else if(Key.getCode() == TOPARROW && this._parent._visible){
					controlHolder.transcriptBtn.gotoAndStop("rollOver");
					showTranscript();
				}else if(Key.getCode() == BOTTOMARROW && this._visible && !transcriptActive && this._parent._visible){
					if (controlHolder.stop._visible && controlHolder.stop.enabled) {
						controlHolder.stop.gotoAndStop("rollOver");
					} else if (controlHolder.play.enabled) {
						controlHolder.play.gotoAndStop("rollOver");
					}
				} else if(Key.getCode() == END && _root.transcript._visible){
					_root.transcript.transcriptAnim.closeBtn.onRollOver();
				}
			}
			
			this.onKeyUp = function(){
				if(Key.getCode() == LEFTARROW && this._visible && !transcriptActive && controlHolder.left.enabled){
					controlHolder.left.onRelease();
					controlHolder.left.gotoAndStop("normal");
				}else if(Key.getCode() == RIGHTARROW && this._visible && !transcriptActive && controlHolder.right.enabled){
					controlHolder.right.onRelease();
					controlHolder.right.gotoAndStop("normal");
				}else if(Key.getCode() == BOTTOMARROW && this._visible && !transcriptActive){
					if (controlHolder.stop._visible && controlHolder.stop.enabled) {
						controlHolder.stop.onRelease();
						controlHolder.stop.gotoAndStop("normal");
					} else if (controlHolder.play.enabled) {
						controlHolder.play.onRelease();
						controlHolder.play.gotoAndStop("normal");
					}
				}else if(Key.getCode() == TOPARROW && this._visible){
					// stopping closing of transcript on keyUP
					
					//controlHolder.transcriptBtn.gotoAndStop("normal");
					//transcriptActive = false;
					//_root.transcript.hideText();
				}
				else if(Key.getCode() == END && _root.transcript._visible){
					_root.transcript.transcriptAnim.closeBtn.onRelease();
					transcriptActive = false;
				}
			}		
			Key.addListener(this);
			controlHolder._alpha = 100;
		} else {
			Key.removeListener(this);
			controlHolder._alpha = 50;
		}
		if (isFirstPage) {
			
		} else {
			controlHolder.left.enabled = flag;
			controlHolder.left._alpha = flag ? 100 : 50;
		}
		if (isLastPage) {
			
		} else {
			controlHolder.right.enabled = flag;
			controlHolder.right._alpha = flag ? 100 : 50;
			
		}
		controlHolder.play.enabled = flag;
		controlHolder.play._alpha = flag ? 100: 50;
		controlHolder.stop.enabled = flag;
		controlHolder.stop._alpha = flag ? 100: 50;
		controlHolder.transcriptBtn.enabled = flag;
		controlHolder.transcriptBtn._alpha = flag ? 100: 50;
	}
	
	public function makeFirstPage(flag:Boolean) {
		isFirstPage = flag;
		if (isFirstPage) {
			controlHolder.left.enabled = flag ? false : true;
			controlHolder.left._alpha = flag ? 50 : 100;
		}
	}
	public function makeLastPage(flag:Boolean) {
		isLastPage = flag;
		if (isLastPage) {
			controlHolder.right.enabled = flag ? false : true;
			controlHolder.right._alpha = flag ? 50 : 100;
		}
	}
	
	public function resetControls(flag) {
		controlHolder.play._visible = flag ? false : true;
		controlHolder.stop._visible = flag;
	}
	public function setAllInactiveWhenLoading() {
		
		var arr = new Array();
		arr.push(controlHolder.left);
		arr.push(controlHolder.right);
		arr.push(controlHolder.play);
		arr.push(controlHolder.pause);
		arr.push(controlHolder.transcriptBtn);
		
		var len = arr.length;
		for (var k = 0; k < len; k++) {
			arr[k].enabled = false;
			arr[k]._alpha = 50;
		
		}
		
	}
	
	
	public function setAllActive(flag) {
		if (!flag) {
			setupKeyBoardInteractions(false);
		} else {
			setControlInteractions();
		}
		
		var len = stepContainer.length;
		for (var k = 0; k < len; k++) {
			stepContainer[k].enabled = flag;
		}
		
		
		if (isFirstPage) {
			
		} else {
			controlHolder.left.enabled = flag;
			controlHolder.left._alpha = flag ? 100 : 50;
		} 
		if (isLastPage) {
			
		} else {
			controlHolder.right.enabled = flag;
			controlHolder.right._alpha = flag ? 100 : 50;
		}
		controlHolder.play.enabled = flag;
		controlHolder.stop.enabled = flag;
		controlHolder.transcriptBtn.enabled = flag;
		
		
		
	}
	private function setControlInteractions(){
		var refObj = this;
		
		
		controlHolder.left.onRollOver = function(){
			this.gotoAndStop("rollOver");
		}
		
		controlHolder.left.onRollOut = controlHolder.left.onReleaseOutside = function(){
			this.gotoAndStop("normal");
		}		
		
		controlHolder.left.onRelease = function(){
			if(refObj.currentStepPos != 0){
				//clearInterval(refObj.stepTimer);
				refObj.currentStepPos--;
				refObj.stepContainer[refObj.currentStepPos].onRelease();
				refObj.pageIndicator._x = refObj.stepContainer[refObj.currentStepPos]._x + refObj.stepContainer[refObj.currentStepPos]._width/2 - refObj.pageIndicator._width/2;
				refObj.pageIndicator._y = refObj.stepContainer[refObj.currentStepPos]._y + refObj.stepContainer[refObj.currentStepPos]._height/2 - refObj.pageIndicator._height/2;				
			}
		}
		
		controlHolder.right.onRollOver = function(){
			this.gotoAndStop("rollOver");
		}
		
		controlHolder.right.onRollOut = controlHolder.right.onReleaseOutside = function(){
			this.gotoAndStop("normal");
		}		
		
		
		
		controlHolder.right.onRelease = function(){
			if(refObj.currentStepPos != refObj.stepContainer.length-1){
				refObj.currentStepPos++;
				refObj.stepContainer[refObj.currentStepPos].onRelease();
				refObj.pageIndicator._x = refObj.stepContainer[refObj.currentStepPos]._x + refObj.stepContainer[refObj.currentStepPos]._width/2 - refObj.pageIndicator._width/2;
				refObj.pageIndicator._y = refObj.stepContainer[refObj.currentStepPos]._y + refObj.stepContainer[refObj.currentStepPos]._height/2 - refObj.pageIndicator._height/2;
			} else {
				// added for showing alert at the end of sco
				// handling from contentPage.as
			}
		}
		
		controlHolder.play.onRollOver = function(){
			this.gotoAndStop("rollOver");
		}
		
		controlHolder.play.onRollOut = controlHolder.play.onReleaseOutside = function(){
			this.gotoAndStop("normal");
		}		
		
		controlHolder.play.onRelease = function(){
			/*
			if(!refObj.pageStopped){
				_global.isSoundStopped = true;
				refObj._parent.mediaLoader.stop();
				refObj._parent.mediaLoader.stopAll();
				refObj.pageStopped = true;
			}else{
				*/
				_global.isSoundStopped = false;
				_global.isMediaStopped = false;
				refObj._parent.mediaLoader.play();
				refObj._parent.mediaLoader.startAll();
				refObj._parent.mediaLoader.makeMediaState(false);
				refObj.pageStopped = false;	
				_parent.stop._visible = true;
				this._visible = false;
			//}
		}
					
		controlHolder.stop.onRollOver = function(){
			this.gotoAndStop("rollOver");
		}
		
		controlHolder.stop.onRollOut = controlHolder.stop.onReleaseOutside = function(){
			this.gotoAndStop("normal");
		}		
		
		controlHolder.stop.onRelease = function(){
			//if(!refObj.pageStopped){
				_global.isSoundStopped = true;
				_global.isMediaStopped = true;
				refObj._parent.mediaLoader.stop();
				refObj._parent.mediaLoader.stopAll();
				refObj._parent.mediaLoader.makeMediaState(true);
				refObj.pageStopped = true;
				this._visible = false;
				_parent.play._visible = true;
				/*
			}else{
				_global.isSoundStopped = false;
				refObj._parent.mediaLoader.play();
				refObj._parent.mediaLoader.startAll();
				refObj.pageStopped = false;				
			}
			*/
		}		
		
		controlHolder.transcriptBtn.onRollOver = function(){
			this.gotoAndStop("rollOver");
		}
		
		controlHolder.transcriptBtn.onRollOut = controlHolder.transcriptBtn.onReleaseOutside = function(){
			this.gotoAndStop("normal");
		}
		
		controlHolder.transcriptBtn.onPress = function(){
			if(!refObj.transcriptActive){
				refObj.showTranscript();
			} else {
				refObj.transcriptActive = false;
				_root.transcript.hideText();
			}
		}
		
		/*
		controlHolder.transcriptBtn.onRelease = function(){
			refObj.transcriptActive = false;
			_root.transcript.hideText();
		}		
		*/
		
		setupKeyBoardInteractions(true);
		
	}
	
	private function showTranscript():Void{
		if(!transcriptActive){
			navObj.stop = controlHolder.stop.enabled;
			navObj.play = controlHolder.play.enabled;
			navObj.right = controlHolder.right.enabled;
			navObj.left = controlHolder.left.enabled;
			navObj.transcript = controlHolder.transcriptBtn.enabled;
			_root.transcript._visible = true;
			_root.transcript.showText(_parent.pageObj.step[currentStepPos].transcriptText._value);
			transcriptActive = true;
			_parent.mediaLoader.stopAll();
		}
	}
	
	//paints the comp
	private function showText(){
		taskName.text = pageTitle;
		taskName.autoSize = "left";	
		taskNum.text = currentStepPos + 1;
		taskNum.autoSize = "left";		
	}
	
	private function repositionControls(){
		controlHolder._x = __compWidth - controlHolder._width;
		controlHolder._y = 0;
	}
	
	//exposed event handler
	public function onStepRelease(stepID:String){
		//
	}
	
	public function reset():Void{
		//remove old stuff
		if(stepContainer.length > 0){
			for(var i=0;i<stepContainer.length;i++){
				stepContainer[i].removeMovieClip();
			}
		}
		
		stepContainer = new Array();
		
		this["pageIndicator"].removeMovieClip();		
		
		taskName.htmlText = "";
		taskNum.text = "";
	}
	

}