﻿import com.trina.components.practice.TextBox;
import com.trina.components.practice.BackBox;
import com.trina.components.practice.SingleSelect;
import com.trina.components.practice.MyButton;

class com.trina.components.PracticeComponent extends com.trina.utils.AniMovieClip {
	private var bgBox:BackBox;
	private var feedbackMC:MovieClip;
	private var qMC:TextBox;
	private var option1MC:SingleSelect;
	private var option2MC:SingleSelect;
	private var selectedOption:Number;
	private var submitBtn:MyButton;
	private var shadowMC:MovieClip;
	private var pracObj:Object;
	private var correctAnswer:Number;
	private var invisBtn:Button;
	private var left:MovieClip;
	private var right:MovieClip;
	private var isAnswered:Boolean;
	
	
	private var distance:Number;
	
	function PracticeComponent() {
		// calling init function from 2nd frame	
	}
	
	private function init() {
		stop();
		isAnswered = false;
		feedbackMC._visible = false;
		shadowMC._visible = false;
		var yPos:Number = 35;
		qMC.setText(pracObj.Question._value);
		qMC._visible = false;
		qMC._y = yPos;
		yPos += qMC._height + 10;
		option1MC._y = option2MC._y = yPos;
		option1MC.setOption(pracObj.Answers.Option[0]._value, 1);
		option2MC.setOption(pracObj.Answers.Option[1]._value, 2);
		if (pracObj.Answers.Option[0].answer == "1" || pracObj.Answers.Option[0].answer == 1) {
			correctAnswer = 1;
		} else {
			correctAnswer = 2;
		}
		option1MC._visible = option2MC._visible = false;
		yPos += option1MC._height + 15
		submitBtn._y = option1MC._y + option1MC._height + 22;
		left._y = right._y = submitBtn._y + 23;
		yPos += submitBtn._height + 15;
		submitBtn._visible = false;
		left._visible = right._visible = false;
		bgBox.resizeBox(yPos);
		_parent.rePosition(bgBox._height);
		play();
		
	}
	
	public function showShadow() {
		shadowMC._height = bgBox._height - 15;
		shadowMC._visible = true;
		
	}
	
	public function showOptions() {
		qMC._visible = true;
		option1MC._visible = option2MC._visible = true;
		feedbackMC._visible = true;
		feedbackMC.play();
	}
	
	public function createInteractions() {
		left.onRollOver = function(){
			this.gotoAndStop("rollOver");
		}
		
		left.onRollOut = left.onReleaseOutside = function(){
			this.gotoAndStop("normal");
		}		
		
		left.onRelease = function(){
			_parent.selectOption(1);
		}
		
		right.onRollOver = function(){
			this.gotoAndStop("rollOver");
		}
		
		right.onRollOut = right.onReleaseOutside = function(){
			this.gotoAndStop("normal");
		}		
		right.onRelease = function(){
			_parent.selectOption(2);
		}
		
		
		var LEFTARROW = 37;
		var RIGHTARROW = 39;
		
		this.onKeyDown = function(){
			if(Key.getCode() == LEFTARROW && left.enabled){
				left.gotoAndStop("rollOver");
			}else if(Key.getCode() == RIGHTARROW && right.enabled){
				right.gotoAndStop("rollOver");
			}else if(Key.getCode() == Key.ENTER && this.enabled){
				
			}
		}
		
		this.onKeyUp = function(){
			if(Key.getCode() == LEFTARROW && left.enabled){
				left.onRelease();
				left.gotoAndStop("normal");
			}else if(Key.getCode() == RIGHTARROW && right.enabled){
				right.onRelease();
				right.gotoAndStop("normal");
			}else if(Key.getCode() == Key.ENTER && this.enabled && isAnswered){
				submitAnswer();
			}
		}		
		Key.addListener(this);
	}
	
	public function showLastOptions() {
		stop();
		createInteractions();
		invisBtn.useHandCursor = false;
		submitBtn.changeState(false);
		submitBtn._visible = true;
		left._visible = right._visible = true;
	}
	
	public function selectOption(num:Number) {
		submitBtn.changeState(true);
		option1MC.selectRadio(false);
		option2MC.selectRadio(false);
		isAnswered = true;
		this["option" + num + "MC"].selectRadio(true);
		selectedOption = num;
		if (selectedOption == 1) {
			right.enabled = true;
			left.enabled = false;
			left._alpha = 50;
			right._alpha = 100;
		} else {
			left.enabled = true;
			right.enabled = false;
			left._alpha = 100;
			right._alpha = 50;
		}
	}
	
	public function submitAnswer() {
		isAnswered = false;
		if (selectedOption == correctAnswer) {
			feedbackMC.iconanswer.gotoAndStop(2);
			_parent.playSoundForFeedback(1);
		} else {
			feedbackMC.iconanswer.gotoAndStop(3);
			_parent.playSoundForFeedback(2);
		}
	}
	
	public function showFeedback(num:Number) {
		if (num == 2) {
			feedbackMC.iconanswer.feedbackTxt.htmlText = pracObj.CorrectFeedback._value;
		} else {
			feedbackMC.iconanswer.feedbackTxt.htmlText = pracObj.IncorrectFeedback._value;
		}
		
	}
	
}