﻿//
import mx.core.UIComponent;
class com.trina.components.SubTaskList extends UIComponent{
	static var symbolName:String = "SubTaskList";
	static var symbolOwner:Object = com.trina.components.SubTaskList;

	private var xPos:Number = 14;
	private var defaultYPos:Number = 100;
	private var yPos:Number = defaultYPos;
	private var xPos2:Number = 542;
	private var vPadding:Number = 5;
	private var itemContainer:Array;
	
	private var selectedID;
	private var enterBtn:MovieClip;
	private var subTaskNameTxt;
	private var bgLoader:MovieClip;
	private var pageText;
	private var scoObj:Object;
	private var subTaskObj:Object;
	
	function init(){
		selectedID = this["selectedID"];
		enterBtn = this["enterBtn"];
		subTaskNameTxt = this["subTaskNameTxt"];
		pageText = this["pageText"];		
		bgLoader = this["bgLoader"];
		
		this.onLoad = function(){
			//markScoCompleted();
			selectedID.tabEnabled = true;
			selectedID.tabIndex = 1;
			enterBtn.tabEnabled = true;
			enterBtn.tabIndex = 2;
					
			selectedID.restrict = "0-9";
			resetState(true);
			resetIDField();
	
			Selection.setFocus(selectedID);
			initList();
			
		}
		scoObj = new Object();
	}
	
	public function initList() {
		itemContainer = new Array();
		if(_global.subtaskID != undefined){
			for(var i=0;i<_global.courseObj.aggregate.length;i++){
				for(var j=0;j<_global.courseObj.aggregate[i].variant.length;j++){
					for(var k=0;k<_global.courseObj.aggregate[i].variant[j].task.length;k++){
						if(_global.courseObj.aggregate[i].variant[j].task[k].id == _global.subtaskID){
							subTaskName = _global.courseObj.aggregate[i].variant[j].task[k].name._value;
							//subTaskListClip.loadBG(_global.courseObj.aggregate[i].variant[j].task[k].bgImage);
							showTaskItems(_global.courseObj.aggregate[i].variant[j].task[k]);
							playPageAudio(_global.courseObj.aggregate[i].variant[j].task[k].pageAudio._value);
							_global.navObject.aggregate = (i + 1) < 10 ? ("0" + (i + 1)) : ("" + (i + 1));
							_global.navObject.variant = (j + 1) < 10 ? ("0" + (j + 1)) : ("" + (j + 1));
							_global.navObject.task = (k + 1) < 10 ? ("0" + (k + 1)) : ("" + (k + 1));
							break;
						}			
					}
				}
			}
		}
	}
	
	//Public
	public function showTaskItems(obj:Object):Void{
		subTaskObj = obj;
		xPos = 14;
		yPos = defaultYPos;
		selectedID.text = "";
		//clear previous taskItems
		clearPreviousTaskItems();
		
		var subTaskLen:Number = 0;
		var i:Number = 0;
		var subTaskItem:MovieClip;
		//Show Page text
		pageText.text = subTaskObj.text._value;				
		
		subTaskLen = subTaskObj.subTask.length;
		
		for(i=0;i<subTaskLen;i++){
			var name = _global.accessKey + "_data";
			var so:SharedObject = SharedObject.getLocal(name);
			var varName = subTaskObj.subTask[i].id;
			var scoCompleted = false;
			/*
			if (so.data[varName]) {
				scoCompleted = true;
			}
			*/
			
			var len = _global.completedArray.length;
			for (var y = 0; y < len; y++) {
				if (varName == _global.completedArray[y]) {
					scoCompleted = true;
					break;
				}
			}
			subTaskItem = this.createObject("subTaskItem", "subTaskItem" + this.getNextHighestDepth(), this.getNextHighestDepth(), {_x:xPos, _y:yPos});
			var iName = (subTaskObj.subTask[i].name._value == undefined)? "" : subTaskObj.subTask[i].name._value;
			var iText = (subTaskObj.subTask[i].text._value == undefined)? "" : subTaskObj.subTask[i].text._value;
			var tag;
			if (scoCompleted) {
				tag = "<font color=\"#006600\">";
			} else {
				tag = "<font color=\"#08495D\">";
			}
			subTaskItem.itemTxt.htmlText = tag + "<b>" + iName + "</b></font>";
			subTaskItem.itemID.text = i+1;
			subTaskItem.itemID.autoSize = "center";
			subTaskItem.id = subTaskObj.subTask[i].id;
			subTaskItem.state = subTaskObj.subTask[i].state == "false" ? false : true;

			subTaskItem.pageSeqId = i + 1;
			subTaskItem.soundPath = subTaskObj.subTask[i].buttonAudio._value;
			if (scoCompleted) {
				subTaskItem.completedMC = subTaskItem.attachMovie("completeMC", "completeMC", i + 1);
				subTaskItem.completedMC._x = 403;
				subTaskItem.completedMC._y = 7;
			}
			
			itemContainer.push(subTaskItem);
			
			//set item level interactions
			setItemInteractions(subTaskItem);
			
			yPos += subTaskItem._height + vPadding;
			
			if(i ==  8){
				xPos = xPos2;
				yPos = defaultYPos;
			}
		}
		
		//set global interactions for this page
		setInteractions();
		
	}
	
	// Stores sco completion status in sharedObject
	public function markScoCompleted() {
		if (_global.isScoCompleted == undefined) {
			return;
		}
		var name = _global.accessKey + "_data";
		var so:SharedObject = SharedObject.getLocal(name);
		var varName = _global.selectedSco;
		if (so.data[varName]) {
			return;
		}
		so.data[varName] = true;
		so.flush();
		_global.isScoCompleted = undefined;
	}
	
	//Clears previously shown tasks if any
	private function clearPreviousTaskItems():Void{
		var i:Number = 0;
		
		for(i=0;i<itemContainer.length;i++){
			itemContainer[i].removeMovieClip();
		}
	}
	
	//set the interactions for the enter button
	private function setInteractions():Void{
		var refObj = this;
		
		setupKeyBoardInteractions(true);
		
		enterBtn.onRollOver = function(){
			this.gotoAndStop("rollOver");
		}
		
		enterBtn.onRollOut = enterBtn.onReleaseOutside = function(){
			this.gotoAndStop("normal");
		}				
		
		enterBtn.onRelease = function(){
			if(!isNaN(Number(refObj.selectedID.text)) && refObj.itemContainer[Number(refObj.selectedID.text)-1].id  != undefined){
				

				if (refObj.itemContainer[Number(refObj.selectedID.text)-1].state) {
					refObj.onItemSelected(refObj.itemContainer[Number(refObj.selectedID.text)-1].id, refObj.itemContainer[Number(refObj.selectedID.text)-1].pageSeqId);
				} else {
					refObj.setCursorSelection();
				}
			} else {
				refObj.setCursorSelection();
			}
		}		
	}
	
	public function setCursorSelection() {
		Selection.setFocus("_level0.subTaskListClip.selectedID");
		Selection.setSelection(0, 0);
	}
	
	public function setupKeyBoardInteractions(flag:Boolean) {
		if (flag) {
			this.onKeyDown = function(){
				if(Key.getCode() == Key.ENTER  && this._visible)
					enterBtn.gotoAndStop("rollOver");
			}		
			
			this.onKeyUp = function(){
				if(Key.getCode() == Key.ENTER  && this._visible && !isNaN(Number(selectedID.text))){
					enterBtn.gotoAndStop("normal");
					if(itemContainer[Number(selectedID.text)-1].id  != undefined){
						if (itemContainer[Number(selectedID.text)-1].state) {
							onItemSelected(itemContainer[Number(selectedID.text)-1].id, itemContainer[Number(selectedID.text)-1].pageSeqId);
						}
					}
				}
			};
			Key.addListener(this);	
			var len = itemContainer.length;
			for (var k = 0; k < len; k++) {
				setItemInteractions(itemContainer[k]);
			}
			enterBtn.enabled = true;
		} else {
			Key.removeListener(this);
			var len = itemContainer.length;
			for (var k = 0; k < len; k++) {
				itemContainer[k].btn.enabled = false;
				itemContainer[k]._alpha = 50;
			}
			enterBtn.enabled = false;
		}
	}
	
	private function setItemInteractions(item:MovieClip):Void{
		var refObj = this;
		
		item.btn.onRollOver = function(){
			if(this._parent.soundPath != undefined && _global.pageSoundsCompleted){
				_root.playSound(this._parent.soundPath);
			}
		}
		
		item.btn.onRollOut = function(){
			if(_global.pageSoundsCompleted){
				_root.stopSound();
			}
		}		
		
		item.btn.onRelease = function(){
			refObj.onItemSelected(this._parent.id, this._parent.pageSeqId);
		}
		
		if (item.state) {
			item.btn.enabled = true;
			item._alpha = 100;
		} else {
			item.btn.enabled = false;
			item._alpha = 50;
		}
	}
	
	//public function
	public function onItemSelected(itemID, pageId){
		_global.navObject.subtask = itemID;
		_global.navObject.page = (pageId) < 10 ? ("0" + pageId) : ("" + pageId);
		scoObj.itemId = itemID;
		_global.selectedSco = itemID;
		scoObj.pageId = pageId;
		_global.appPath.showPageContent(itemID);
		
	}
	
	//loads the image from the specified path
	public function loadBG(imPath){
		bgLoader.loadMovie(imPath);
	}		
	
	//page audio
	public function playPageAudio(path):Void{
		//Page Audio
		//stop old sounds
		_root.stopSound();
		if(path != undefined){
			_root.playPageSound(path);
		}										
	}
	
	public function resetState(flag:Boolean) {
		showTaskItems(subTaskObj);
		this._visible = flag;
	}
	
	
	public function resetIDField(){
		selectedID.text = "";
	}	
	
	//getter setter functions
	[Inspectable(name = "subTaskName", type="String")]
	function set subTaskName(vVal:String):Void{
		subTaskNameTxt.text = vVal;
	}
	
	function get subTaskName():String{
		return subTaskNameTxt.text;
	}
	//end of getter setter functions			
}