﻿//
import mx.core.UIComponent;
class com.trina.components.TaskList extends UIComponent {
	static var symbolName:String = "TaskList";
	static var symbolOwner:Object = com.trina.components.TaskList;


	private var xPos:Number = 14;
	private var defaultYPos:Number = 100;
	private var yPos:Number = defaultYPos;
	private var xPos2:Number = 545;
	private var vPadding:Number = 5;
	private var itemContainer:Array;
	
	private var selectedID;
	private var enterBtn:MovieClip;
	private var variantNameTxt;
	private var bgLoader:MovieClip;
	private var pageText;
	private var taskObj:Object;
	
	function init(){
		selectedID = this["selectedID"];
		enterBtn = this["enterBtn"];
		variantNameTxt = this["variantNameTxt"];
		pageText = this["pageText"];
		bgLoader = this["bgLoader"];
		
		this.onLoad = function(){
			selectedID.tabEnabled = true;
			selectedID.tabIndex = 1;
			enterBtn.tabEnabled = true;
			enterBtn.tabIndex = 2;
			
			selectedID.restrict = "0-9";
			
			initList();
			resetState(true);
			resetIDField();
			Selection.setFocus(selectedID);
		}				
	}
	
	public function initList() {
		itemContainer = new Array();
		if(_global.taskID != undefined){
			var len = _global.courseObj.aggregate.length;
			for(var i=0;i<len;i++){
				for(var j=0;j<_global.courseObj.aggregate[i].variant.length;j++){
					if(_global.courseObj.aggregate[i].variant[j].id == _global.taskID){
						variantName = _global.courseObj.aggregate[i].variant[j].name._value;
						//taskListClip.loadBG(_global.courseObj.aggregate[i].variant[j].bgImage);
						showTaskItems(_global.courseObj.aggregate[i].variant[j]);
						playPageAudio(_global.courseObj.aggregate[i].variant[j].pageAudio._value);
						_root.pageTitle.text = 	_global.courseObj.aggregate[i].variant[j].variantTitle._value;
	
						break;
					}			
				}
			}
		}
	}
	
	//Public
	public function showTaskItems(tObj):Void{
		taskObj = tObj;
		xPos = 14;
		yPos = defaultYPos;
		selectedID.text = "";
		
		//clear previous taskItems
		clearPreviousTaskItems();
		var taskLen:Number = 0;
		var i:Number = 0;
		var taskItem:MovieClip;
		
		
		//Show Page text
		pageText.text = taskObj.text._value;		
		
		
		taskLen = taskObj.task.length;
		
		
		for(i=0;i<taskLen;i++){
			var isCompleted = checkTaskCompleted(i);
			taskItem = this.createObject("taskItem", "taskItem" + this.getNextHighestDepth(), this.getNextHighestDepth(), {_x:xPos, _y:yPos});
			var iName = (taskObj.task[i].name._value == undefined)? "" : taskObj.task[i].name._value;
			var iText = (taskObj.task[i].text._value == undefined)? "" : taskObj.task[i].text._value;
			
			
			var tag;
			if (isCompleted) {
				tag = "<font color=\"#006600\">";
			} else {
				tag = "<font color=\"#08495D\">";
			}
			taskItem.itemTxt.htmlText = tag + "<b>" + iName + "</b></font>";
			
			taskItem.itemID.text = i+1;
			taskItem.itemID.autoSize = "center";
			taskItem.id = taskObj.task[i].id;
			taskItem.state = taskObj.task[i].state == "false" ? false : true;
			taskItem.soundPath = taskObj.task[i].buttonAudio._value;
			if (isCompleted) {
				taskItem.completedMC = taskItem.attachMovie("completeMC", "completeMC", i + 1);
				taskItem.completedMC._x = 403;
				taskItem.completedMC._y = 7;
			}	
				
			itemContainer.push(taskItem);
			
			//set item level interactions
			setItemInteractions(taskItem);

			yPos += taskItem._height + vPadding;
			
			if(i ==  6){
				xPos = xPos2;
				yPos = defaultYPos;
			}
		}
		
		//set global interactions for this page
		setInteractions();
		
	}
	
	public function checkTaskCompleted(num:Number) {
		var bool = true;
		var len = taskObj.task[num].subTask.length;
		
		for (var k = 0; k < len; k++) {
			var subTaskObj = taskObj.task[num].subTask[k];
			//var name = _global.accessKey + "_data";
			//var so:SharedObject = SharedObject.getLocal(name);
			var varName = subTaskObj.id;
			var scoCompleted = false;
			var len = _global.completedArray.length;
			for (var y = 0; y < len; y++) {
				if (varName == _global.completedArray[y]) {
					scoCompleted = true;
					break;
				}
			}
			if (!scoCompleted) {
				bool = false;
				break;
			}
			
		}
		return bool;
	}
	
	//Clears previously shown tasks if any
	private function clearPreviousTaskItems():Void{
		var i:Number = 0;
		
		for(i=0;i<itemContainer.length;i++){
			itemContainer[i].removeMovieClip();
		}
	}
	
	//set the interactions for the enter button
	private function setInteractions():Void{
		var refObj = this;
		
		setupKeyBoardInteractions(true);
		
		enterBtn.onRollOver = function(){
			this.gotoAndStop("rollOver");
		}
		
		enterBtn.onRollOut = enterBtn.onReleaseOutside = function(){
			this.gotoAndStop("normal");
		}		
		
		enterBtn.onRelease = function(){
			if(!isNaN(Number(refObj.selectedID.text)) && refObj.itemContainer[Number(refObj.selectedID.text)-1].id  != undefined){
				if (refObj.itemContainer[Number(refObj.selectedID.text)-1].state) {
					refObj.onItemSelected(refObj.itemContainer[Number(refObj.selectedID.text)-1].id);
				} else {
					refObj.setCursorSelection();
				}
			} else {
				refObj.setCursorSelection();
			}
		}		
	}
	public function setCursorSelection() {
		Selection.setFocus("_level0.taskListClip.selectedID");
		Selection.setSelection(0, 0);
	}

	public function setupKeyBoardInteractions(flag:Boolean) {
		if (flag) {
			this.onKeyDown = function(){
				if(Key.getCode() == Key.ENTER  && this._visible)
					enterBtn.gotoAndStop("rollOver");
			}		
			
			this.onKeyUp = function(){
				if(Key.getCode() == Key.ENTER  && this._visible && !isNaN(Number(selectedID.text))){
					enterBtn.gotoAndStop("normal");
					if(itemContainer[Number(selectedID.text)-1].id  != undefined){
						if (itemContainer[Number(selectedID.text)-1].state) {
							onItemSelected(itemContainer[Number(selectedID.text)-1].id);
						}
					}
				}
			};
			Key.addListener(this);	
			var len = itemContainer.length;
			for (var k = 0; k < len; k++) {
				setItemInteractions(itemContainer[k]);
			}
			enterBtn.enabled = true;
		} else {
			Key.removeListener(this);
			var len = itemContainer.length;
			for (var k = 0; k < len; k++) {
				itemContainer[k].btn.enabled = false;
				itemContainer[k]._alpha = 50;
			}
			enterBtn.enabled = false;
		}
	}
	
	public function resetState(flag:Boolean) {
		var taskLen = taskObj.task.length;
		
		for(var i = 0; i < taskLen; i++){
			var isCompleted = checkTaskCompleted(i);
			var taskItem = itemContainer[i];
			
			var tag;
			if (isCompleted) {
				tag = "<font color=\"#006600\">";
			} else {
				tag = "<font color=\"#08495D\">";
			}
			var iName = (taskObj.task[i].name._value == undefined)? "" : taskObj.task[i].name._value;
			taskItem.itemTxt.htmlText = tag + "<b>" + iName + "</b></font>";
			

			if (isCompleted) {
				taskItem.completedMC = taskItem.attachMovie("completeMC", "completeMC", i + 1);
				taskItem.completedMC._x = 403;
				taskItem.completedMC._y = 7;
			} else {
				taskItem.completedMC.removeMovieClip();
			}
		}
		this._visible = flag;
	}
	
	private function setItemInteractions(item:MovieClip):Void{
		var refObj = this;
		
		item.btn.onRollOver = function(){
			if(this._parent.soundPath != undefined && _global.pageSoundsCompleted){
				_root.playSound(this._parent.soundPath);
			}
		}
		
		item.btn.onRollOut = function(){
			if(_global.pageSoundsCompleted){
				_root.stopSound();
			}
		}		
		
		item.btn.onRelease = function(){
			refObj.onItemSelected(this._parent.id);
		}
		
		if (item.state) {
			item.btn.enabled = true;
			item._alpha = 100;
		} else {
			item.btn.enabled = false;
			item._alpha = 50;
		}
	}
	
	//public function
	public function onItemSelected(itemID:String){
		_global.appPath.showSubTaskList(itemID);
	}
	
	//loads the image from the specified path
	public function loadBG(imPath){
		bgLoader.loadMovie(imPath);
	}		
	
	//page audio
	public function playPageAudio(path):Void{
		//Page Audio
		//stop old sounds
		_root.stopSound();
		if(path != undefined){
			_root.playPageSound(path);
		}										
	}	
	
	public function resetIDField(){
		selectedID.text = "";
	}
	
	public function closeThis() {
		this.removeMovieClip();
		this.destroyObject();
	}
	
	//getter setter functions
	[Inspectable(name = "variantName", type="String")]
	function set variantName(vVal:String):Void{
		variantNameTxt.text = vVal;
	}
	
	function get variantName():String{
		return variantNameTxt.text;
	}
	//end of getter setter functions		
}