﻿//
import mx.core.UIComponent;
class com.trina.components.VariantList extends UIComponent{
	static var symbolName:String = "VariantList";
	static var symbolOwner:Object = com.trina.components.VariantList;
	
	private var aggregateNameTxt;
	private var selectedID;
	private var enterBtn;
	private var variantHolder;
	private var itemContainer:Array;
	private var bgLoader:MovieClip;
	private var pageText;
	private var leftBtn:MovieClip;
	private var rightBtn:MovieClip;
	
	function VariantList(){
		aggregateNameTxt = this["aggregateNameTxt"];
		selectedID = this["selectedID"];
		enterBtn = this["enterBtn"];
		variantHolder = this["variantHolder"];
		pageText = this["pageText"];
		bgLoader = this["bgLoader"];
		leftBtn = this["leftBtn"];
		rightBtn = this["rightBtn"];
		
		this.onLoad = function(){
			selectedID.tabEnabled = true;
			selectedID.tabIndex = 1;
			enterBtn.tabEnabled = true;
			enterBtn.tabIndex = 2;
			
			selectedID.restrict = "0-9";
			resetIDField()
			Selection.setFocus(selectedID);
			initList();
		}		
	}
	
	public function initList() {
		itemContainer = new Array();
		var len = _global.courseObj.aggregate.length;
		for(var i=0;i<len;i++){
			if(_global.courseObj.aggregate[i].id == _global.variantID){
				aggregateName = _global.courseObj.aggregate[i].name._value;
				loadBG(_global.courseObj.aggregate[i].bgImage);
				showVariantItems(_global.courseObj.aggregate[i]);
				playPageAudio(_global.courseObj.aggregate[i].pageAudio._value);
				break;
			}
		}
	}

	public function showVariantItems(aggregateObj:Object):Void{
		var variantLen:Number = 0;
		var i:Number = 0;
		var variantItem:MovieClip;
		var xPos:Number = 0;
		var yPos:Number = 0;
		
		//clear previous taskItems
		clearPreviousTaskItems();
		
		//Show Page text
		pageText.text = aggregateObj.text._value;
		
		variantLen = aggregateObj.variant.length;
		
		if(variantLen < 5){
			leftBtn._visible = false;
			rightBtn._visible = false;
		}else{
			leftBtn._visible = true;
			rightBtn._visible = true;
		}

		for(i=0;i<variantLen;i++){
			variantItem = variantHolder.createObject("variantItem", "variantItem" + variantHolder.getNextHighestDepth(), variantHolder.getNextHighestDepth(), {_x:xPos, _y:yPos});
			var iName = (aggregateObj.variant[i].name._value == undefined)? "" : aggregateObj.variant[i].name._value;
			var iText = (aggregateObj.variant[i].buttonText._value == undefined)? "" : aggregateObj.variant[i].buttonText._value;
			
			variantItem.itemTxt.htmlText = "<b>" + iName + "<br>" + iText + "</b>";			
			variantItem.itemID.text = i+1;
			variantItem.itemID.autoSize = "center";
			variantItem.id = aggregateObj.variant[i].id;
			variantItem.state = aggregateObj.variant[i].state == "false" ? false : true;
			variantItem.soundPath = aggregateObj.variant[i].buttonAudio._value;
			variantItem.bgLoader.loadMovie(aggregateObj.variant[i].bgImage);
			itemContainer.push(variantItem);
			
			//set item level interactions
			setItemInteractions(variantItem);
			
			xPos += variantItem._width;
		}
		
		//set global interactions for this page
		setInteractions();		
	}
	
	//Clears previously shown tasks if any
	private function clearPreviousTaskItems():Void{
		var i:Number = 0;
		
		for(i=0;i<itemContainer.length;i++){
			itemContainer[i].removeMovieClip();
		}
	}
	
	//set the interactions for the enter button
	private function setInteractions():Void{
		var refObj = this;
		
		setupKeyBoardInteractions(true);
		
		enterBtn.onRollOver = function(){
			this.gotoAndStop("rollOver");
		}
		
		enterBtn.onRollOut = enterBtn.onReleaseOutside = function(){
			this.gotoAndStop("normal");
		}		
		
		enterBtn.onRelease = function(){
			if(!isNaN(Number(refObj.selectedID.text)) && refObj.itemContainer[Number(refObj.selectedID.text)-1].id  != undefined){
				if (refObj.itemContainer[Number(refObj.selectedID.text)-1].state) {
					refObj.onItemSelected(refObj.itemContainer[Number(refObj.selectedID.text)-1].id);
				} else {
					refObj.setCursorSelection();
				}
			} else {
				refObj.setCursorSelection();
			}
		}		
	}
	
	public function setCursorSelection() {
		Selection.setFocus("_level0.variantListClip.selectedID");
		Selection.setSelection(0, 0);
	}
	
	public function setupKeyBoardInteractions(flag:Boolean) {
		if (flag) {
			this.onKeyDown = function(){
				if(Key.getCode() == Key.ENTER  && this._visible)
					enterBtn.gotoAndStop("rollOver");
			}
			
			this.onKeyUp = function(){
				if(Key.getCode() == Key.ENTER  && this._visible && !isNaN(Number(selectedID.text))){
					enterBtn.gotoAndStop("normal");
					if(itemContainer[Number(selectedID.text)-1].id  != undefined){
						if (itemContainer[Number(selectedID.text)-1].state) {
							onItemSelected(itemContainer[Number(selectedID.text)-1].id);
						}
					}
				}
			};
			Key.addListener(this);	
			var len = itemContainer.length;
			for (var k = 0; k < len; k++) {
				setItemInteractions(itemContainer[k]);
			}
			enterBtn.enabled = true;
		} else {
			Key.removeListener(this);
			var len = itemContainer.length;
			for (var k = 0; k < len; k++) {
				itemContainer[k].btn.enabled = false;
				itemContainer[k]._alpha = 50;
			}
			enterBtn.enabled = false;
		}
	}
	
	private function setItemInteractions(item:MovieClip):Void{
		var refObj = this;
		
		item.btn.onRollOver = function(){
			if(this._parent.soundPath != undefined && _global.pageSoundsCompleted){
				_root.playSound(this._parent.soundPath);
			}
		}
		
		item.btn.onRollOut = function(){
			if(_global.pageSoundsCompleted){
				_root.stopSound();
			}
		}		
		
		
		item.btn.onRelease = function(){
			refObj.onItemSelected(this._parent.id);
		}
		
		if (item.state) {
			item.btn.enabled = true;
			item._alpha = 100;
		} else {
			item.btn.enabled = false;
			item._alpha = 50;
		}
	}
	
	//public function
	public function onItemSelected(itemID:String){
		_global.appPath.showTaskList(itemID)
	}
	
	//loads the image from the specified path
	public function loadBG(imPath){
		bgLoader.loadMovie(imPath);
	}
	
	//page audio
	public function playPageAudio(path):Void{
		//Page Audio
		//stop old sounds
		_root.stopSound();
		if(path != undefined){
			_root.playPageSound(path);
		}										
	}	
	
	public function resetIDField(){
		selectedID.text = "";
	}
	
	//getter setter functions
	[Inspectable(name = "aggregateName", type="String")]
	function set aggregateName(uVal:String):Void{
		aggregateNameTxt.text = uVal;
	}
	
	function get aggregateName():String{
		return aggregateNameTxt.text;
	}
	//end of getter setter functions		
	
}