﻿class com.trina.help.HelpContainer extends MovieClip {
	private var pagesArray:Array;
	private var xPos:Number;
	private var yPos:Number;
	private var gap:Number;
	private var totalPages:Number;
	private var containerMC:MovieClip;
	private var currentObj:Object;
	private var helpSound:Sound;
	private var mId:Number;
	private var currentSoundPos:Number;
	private var mcArray:Array;
	private var lastMC:MovieClip;
	private var closeBtn:MovieClip;
	
	
	function HelpContainer() {
		this.onLoad = function () {
			init();
		}
	}
	
	public function init() {
		_root.path6 = this;
		xPos = 188;
		yPos = 101;
		gap = 23;
	}
	
	public function showHelp() {
			
		if (_global.helpVisited) {
			// do nothing
		} else {
			var name = _global.accessKey + "_data";
			var so:SharedObject = SharedObject.getLocal(name);
			var varName = "helpVisited";
			so.data[varName] = true;
			so.flush();
		}
		
		totalPages = 0;
		// First create the pagesArray from the help Obj
		pagesArray = new Array();
		var mObj = _global.helpObj.help;
		var stepLen = mObj.step.length;
		
		for (var k = 0; k < stepLen; k++) {
			var stepObj = mObj.step[k];
			var obj:Object = new Object();
			if (stepObj.page._type == "array") {
				obj.id = stepObj.id;
				obj.pages = stepObj.page;
			} else {
				obj.id = stepObj.id;
				obj.pages = new Array();
				obj.pages.push(stepObj.page);
			}
			pagesArray.push(obj);
			totalPages++;
			// pagesArray will have each step obj as an element
		}
		
		// now create the layout
		mcArray = new Array();
		var len = pagesArray.length;
		var bIndex:Number = 1;
		for (var i = 0; i < len; i++) {
			var arr = pagesArray[i];
			var len1 = arr.pages.length;
			for (var k = 0; k < len1; k++) {
				var obj = arr.pages[k];
				obj.id = arr.id;
				obj.pageIndex = bIndex;
				obj.pageNumber = k;
				obj.totalPages = len1;
				var mc = this.attachMovie("pageIndicator", "p" + bIndex, bIndex, {pObj:obj});
				mc._x = xPos + ((bIndex - 1) * gap);
				mc._y = yPos;
				bIndex++;
				mcArray.push(mc);
			}
		}
		delete mObj;
		delete stepLen;
		
		this._visible = true;
		setInteractions();
		showPage(_global.helpIndexId[_global.currentClip._name], 0);
		_parent.closeHelp();  // comment if you want intro screen to be visible;
	}
	
	private function setInteractions() {
		
		closeBtn.onRollOver = function(){
			this.gotoAndStop("rollOver");
		}
		
		closeBtn.onRollOut = closeBtn.onReleaseOutside = function(){
			this.gotoAndStop("normal");
		}				
		
		closeBtn.onRelease = function(){
			this.gotoAndStop("normal");
			_parent.closeWindow();
		}
		
		
		Key.removeListener();
		this.onKeyDown = function(){
			if(Key.getCode() == Key.END  && this._visible) {
				closeBtn.onRollOver();
			}
		}
		
		this.onKeyUp = function(){
			if(Key.getCode() == Key.END  && this._visible){//close window
				closeBtn.onRelease();
			}
		};
		Key.addListener(this);	
	}
	// called when any pageIndicator is clicked
	public function handlePageSelection(id:Number, pageNumber:Number) {
		showPage(id, pageNumber);
	}
	
	public function getCurrentPageNumber(id, num) {
		var len = pagesArray.length;
		var total = 0;
		if (id - 1 > 0) {
			for (var k = 0; k < id - 1; k++) {
				total += pagesArray[k].pages.length;
			}
		}
		total += num + 1;
		return total;
		
	}
	
	public function makeThisPageActive(num) {
		lastMC.setActive(true);
		mcArray[num - 1].setActive(false);
		lastMC = mcArray[num - 1];
	}
	public function showPage(id:Number, num:Number) {
		var cPage = getCurrentPageNumber(id, num);
		makeThisPageActive(cPage);
		currentObj = pagesArray[id - 1].pages[num];
		loadClip(currentObj.graphic.src);
		if (currentObj.audio.src != undefined && currentObj.audio.src.length > 0) {
			loadAudio(currentObj.audio.src);
		} else {
			_global.helpSoundLoaded = false;
			_global.helpSoundCompleted = false;
		}
		clearInterval(mId);
		mId = setInterval(this, "checkAllLoaded", 50);
	}
	
	public function showNextPage() {
		if (currentObj.pageNumber >= currentObj.totalPages -1) {
			if (_global.firstTimeHelp) {
				if (Number(currentObj.id) == pagesArray.length) {
					closeWindow();
				} else {
					showPage((Number(currentObj.id) + 1), 0);
				}
			}
		} else {
			showPage(currentObj.id, currentObj.pageNumber + 1);
		}
	}
	
	public function checkAllLoaded() {
		if (_global.helpMediaLoaded && _global.helpSoundLoaded) {
			clearInterval(mId);
			delete mId;
			startMedia();		
		}
	}
	
	public function startMedia() {
		containerMC.play();
		helpSound.start(currentSoundPos);
		helpSound.setVolume(100);	
	}
	
	public function cleanUp() {
		containerMC.unloadClip();
		helpSound.stop();
		helpSound = new Sound();
		_global.helpMediaLoaded = false;
		_global.helpSoundLoaded = false;
		_global.helpMediaCompleted = false;
		_global.helpSoundCompleted = false;
	}
	
	public function loadAudio(file) {
		currentSoundPos = 0;
		helpSound = new Sound();
		_global.soundCompleted = false;
		helpSound.onLoad = function (success:Boolean) {
			if (success) {
				helpSound.stop();
				_global.helpSoundLoaded = true;
			} else {
				_global.soundLoaded = true;
				_global.soundCompleted = true;
			}
		}
		if (file == undefined) { 
			// no need of sound complete event as the media file will call for jump 
		} else {
			
			helpSound.onSoundComplete = function () {
				_global.helpSoundCompleted = true;
				_root.path6.jumpForward(true);
			}
		}
		var filePath = "help/audio/";
		helpSound.loadSound(filePath + file, false);
	}
	public function loadClip(fl:String) {
		cleanUp();
		
		var mcListener:Object = new Object();
		mcListener.onLoadStart = function(target_mc:MovieClip) {
		    // show loader here
		};
		mcListener.onLoadComplete = function(target_mc:MovieClip) {
		    //target_mc.completeTimer = getTimer();
		};
		mcListener.onLoadInit = function(target_mc:MovieClip) {
			target_mc.stop();
			_global.helpMediaLoaded = true;
		};
		var mcLoader:MovieClipLoader = new MovieClipLoader();
		mcLoader.addListener(mcListener);
		
		var filePath = "help/media/";
		mcLoader.loadClip(filePath + fl, containerMC);
		
		
	}
	
	
	
	public function jumpForward(flag) {
		if (flag == undefined) {
			_global.helpMediaCompleted = true;
		}
		if (_global.helpMediaCompleted && _global.helpSoundCompleted) {
			showNextPage();
		}
	}
	
	public function closeWindow() {
		cleanUpWhole();
	}
	
	public function cleanUpWhole() {
		cleanUp();
		var len = mcArray.length;
		for (var k = 0; k < len; k++) {
			mcArray[k].removeMovieClip();
			
		}
		_parent.closeHelp();
		
	}
}