﻿import com.trina.utils.XML2Obj;

class com.trina.server.LMSServer extends MovieClip {
	private var statusTxt1:TextField;
	private var statusTxt2:TextField;
	private var localip;
	private var sendPort:String;
	private var listenPort:String;
	private var mdm:Object;
	private var btn1:MovieClip;
	private var userxml:XML;
	private var keyArray:Array;
	private var currentClientIP:String;
	private var serverIP:String;
	
	function LMSServer() {
		this.onLoad = function () {
			initServer();
		}
	}
	
	public function initServer() {
		statusTxt1.text += "Server init" + newline;
		_root.pathS = this;
		mdm = _root.mdm;
		serverIP = mdm.Network.IPAddress;
		sendPort = "4000";
		listenPort = "4001";
		mdm.Network.UDP.Socket.startServer(listenPort);
		mdm.Network.UDP.Socket.onData = function(myObject){
	       _root.pathS.onReceiveData(myObject.data);
		}
		
		userxml = new XML();
		userxml.ignoreWhite = true;
		userxml.onLoad = function () {
			var xo:XML2Obj = new XML2Obj();
			var tObj = xo.getxObjFromXML(this.toString());
			_root.pathS.assignValues(tObj);
		}
		userxml.load("../../resources/userData/userDB.xml");
	}
	
	public function assignValues(obj:Object) {
		var len = obj.userList.user.length;
		keyArray = new Array();
		for (var k = 0; k < len; k++) {
			keyArray["" + obj.userList.user[k].accessKey] = obj.userList.user[k].userName._value;
		}
		
	}
	
	public function getDataObject(str:String) {
		var str2= str.substring(9, str.length);
		var dataString = str2.split("~");
		var obj:Object = new Object();
		obj.currentClientIP = dataString[0];
		obj.msgType = dataString[1];
		obj.messageStr = dataString[2];		
		return obj;
	}
	
	public function onReceiveData(str1:String) {
		var dataObj:Object = getDataObject(str1);
		switch (dataObj.msgType) {
			case "getServerIP" :
				sendServerIP(dataObj.currentClientIP, dataObj.messageStr);
				break;
			case "validateAccessKey" :
				handleValidateAccessKey(dataObj.currentClientIP, dataObj.messageStr);
				break;
			default :
				break;
		}
		statusTxt1.text += "data received = " + dataObj.currentClientIP + " :: "  + dataObj.messageStr + " :: " + newline;
	}
	
	public function sendServerIP(ip:String, str:String) {
		var msg = "param@eq@sendServerIP~" + serverIP;
		sendData(ip, msg);
	}
	
	public function handleValidateAccessKey(ip:String, str:String) {
		 var name = keyArray[str];
		 var msg = "param@eq@validateAccessKey~" + name;
		 sendData(ip, msg);
	}
	
	public function sendData(ip:String, msg:String) {
		statusTxt2.text += "data sent = " + ip + " :: " + msg + newline;
		mdm.Network.UDP.Socket.send(ip, sendPort, msg);
	}
	
}