﻿// CustomButton.as
/******************************************************************************
* Developer:   Amit Mazumder (email: amitm@trina.biz); Trina Systems ,India 
* Description: This class will create a custom button.
* Date:	12th January, 2006
******************************************************************************/

class com.trina.utils.CustomButton extends MovieClip {
	private var callBackFunction:String;
	private var param; // It can be any type, hence not declared the type
	private var labelTxt:TextField;
	private var nFormat:TextFormat;
	private var oFormat:TextFormat;
	private var iFormat:TextFormat;
	private var isActive:Boolean;
	private var callBackObject:Object;
	private var isHTML:Boolean;
	private var lineMC:MovieClip;
	
	
	function CustomButton() {
		this.onLoad = function () {
			init();
		}
	}
	
	private function init():Void {
		this.onRollOver = function () {
			showRollOver();
		}
		
		this.onRollOut = this.onReleaseOutside = function () {
			showRollOut();
		}
		
		this.onRelease = function () {
			handleRelease();
		}
		
	}
	
	public function handleRelease():Void {
		showRollOut();
		if (param == undefined) {
			callBackObject[callBackFunction]();
		} else {
			callBackObject[callBackFunction](param);
		}
	}
	public function showRollOver():Void {
		if (isActive) {
			gotoAndStop("over");
			labelTxt.setTextFormat(oFormat);
		}
	}
	
	private function showRollOut():Void {
		if (isActive) {
			gotoAndStop("up");
		} else {
			gotoAndStop("inactive");
		}
		labelTxt.setTextFormat(nFormat);
	}
	
	public function initButton(label:String, cbFunction:String, pt:Object, c1:Number, c2:Number, c3:Number, p, state:Boolean):Void {
		isHTML = false;
		nFormat = new TextFormat();
		oFormat = new TextFormat();
		labelTxt.text = label;
		callBackFunction = cbFunction;
		callBackObject = pt;
		nFormat.color = c1 == undefined ? 0xFFFFFF : c1;
		oFormat.color = c2 == undefined ? 0x000000 : c2;
		iFormat.color = ((c3 == undefined) || (c3 == 0)) ? 0x999999 : c3;
		param = p; // either number or string or boolean, can be any type
		if (state != undefined) {
			changeState(state);
		} else {
			isActive = true;
		}
	}
	
	public function initHTMLButton(label:String, cbFunction:String, pt:Object, c1:Number, c2:Number, c3:Number, p, state:Boolean):Void {
		nFormat = new TextFormat();
		oFormat = new TextFormat();
		isHTML = true;
		labelTxt.autoSize = "left";
		labelTxt.htmlText = label;
		callBackFunction = cbFunction;
		callBackObject = pt;
		nFormat.color = c1 == undefined ? 0xFFFFFF : c1;
		oFormat.color = c2 == undefined ? 0x000000 : c2;
		iFormat.color = ((c3 == undefined) || (c3 == 0)) ? 0x999999 : c3;
		param = p; // either number or string or boolean, can be any type
		if (state != undefined) {
			changeState(state);
		} else {
			isActive = true;
		}
	}
	
	public function changeCustomState(flag:Boolean):Void {
		isActive = flag;
		this.enabled = isActive;
	}
	
	public function changeState(flag:Boolean):Void {
		isActive = flag;
		this.enabled = isActive;
		var fr = isActive ? "up" : "inactive";
		if (isActive) {
			labelTxt.setTextFormat(nFormat);
		} else {
			labelTxt.setTextFormat(iFormat);
		}
		gotoAndStop(fr);
		this._alpha = isActive ? 100 : 50;
	}
	
	public function setSelection(flag:Boolean):Void {
		var bool = flag ? false : true
		changeState(bool);
		var fr = flag ? "selected" : "up";
		gotoAndStop(fr);
	}
	
	public function adjustTextField():Void {
		labelTxt._y = (this._height - labelTxt.textHeight) / 2;
		lineMC._y = this._height - 2;
	}
	
	public function changeVisible(flag:Boolean):Void {
		this._visible = flag;
	}
}